subroutine dimension_convert(m, u0, e_ii, kappa, sig, v00, kij, x, fa, &
	&		fb, N_sites,q,mu,xq,xd)

!	This subroutine converts the global parameters defined in the subroutine
!	essentials (which are BIG arrays) into arrays whose dimensions are the
!	ones specified in the problem.

use essentials
implicit none

!	Declaring converted parameters that are passed out of this subroutine
real (KIND=double), intent(out), dimension(ncp) :: m
real (KIND=double), intent(out), dimension(ncp) :: q
real (KIND=double), intent(out), dimension(ncp) :: mu
real (KIND=double), intent(out), dimension(ncp,ncp) :: u0
real (KIND=double), intent(out), dimension(ncp) :: e_ii
real (KIND=double), intent(out), dimension(ncp,ncp,max,max) :: kappa
real (KIND=double), intent(out), dimension(ncp,ncp) :: sig
real (KIND=double), intent(out), dimension(ncp) :: v00
real (KIND=double), intent(out), dimension(ncp,ncp) :: kij
real (KIND=double), intent(out), dimension(ncp) :: x
real (KIND=double), intent(out), dimension(ncp) :: xq
real (KIND=double), intent(out), dimension(ncp) :: xd
real (KIND=double), intent(out), dimension(ncp,ncp,max,max,2) :: fa
real (KIND=double), intent(out), dimension(ncp,ncp,max,max,1) :: fb

integer, intent(out), dimension(ncp) :: N_sites

!	Declaring local variables
integer :: i,j,a,b											! counters
real (KIND=double) :: temp, temp2, temp3, temp4, temp6, temp7, temp8, temp13,temp14,temp15
real (KIND=double) :: temp9, temp10, temp11, temp12, sum, luck, temp16
integer :: temp5

!	Converting the large arrays in the module essentials to fit the problem at 
!	hand.
! assigining zero values to prevent the random allocation that's happening
 do j=1,ncp
	 do a=1,max
	  	 do i=1,ncp
			do b=1,max	
				kappa(j,a,i,b) = 0.0d0
				fa(j,a,i,b,2) = 0.0d0
				fa(j,a,i,b,1) = 0.0d0
				fb(j,a,i,b,1) = 0.0d0
			 end do
		 end do
	 end do
 end do


do i = 1, ncp
  temp = m_tmp(i)
  m(i) = temp
  temp2 = e_ii_tmp(i)
  e_ii(i) = temp2
  temp3 = v00_tmp(i)
  v00(i) = temp3
  temp4 = x_tmp(i)
  x(i) = temp4
  temp5 = N_sites_tmp(i)
  N_sites(i) = temp5
  temp13=q_tmp(i)
  q(i)=temp13
  temp14=mu_tmp(i)
  mu(i)=temp14
  temp15=xd_tmp(i)
  xd(i)=temp15
  temp16=xq_tmp(i)
  xq(i)=temp16

  do j = 1, ncp
	temp6 = sig_tmp(i,j)
	sig(i,j) = temp6
	temp7 = u0_tmp(i,j)
	u0(i,j) = temp7
	temp8 = kij_tmp(i,j)
	kij(i,j) = temp8
  end do
end do

do i = 1, ncp
  do a = 1, N_sites(i)
	do j = 1, ncp
  	  do b = 1, N_sites(j)
		temp9 = fa_tmp(i,j,a,b,2)
		fa(i,j,a,b,2) = temp9
		temp10 = fa_tmp(i,j,a,b,1)
		fa(i,j,a,b,1) = temp10
		temp11 = kappa_tmp(i,j,a,b)
		kappa(i,j,a,b) = temp11
		temp = fb_tmp(i,j,a,b,1)
		fb(i,j,a,b,1) = temp
	  end do
	end do
  end do
end do


END SUBROUTINE