subroutine input_parameters
!	This subroutine provides the values of the parameters used by SAFT.  This subroutine is called
!	by PTdriver and should be run with the package.


!	This code provides the parameters used in the following subroutines & programs
!		PTthermo_props.f90				dispersion.f90
!		ghs_derivatives.f90				hard_chain_eos.f90
!		hbond_thermo.f90				Q_sub.f90
!		zeta_s.f90						hs_cs.f90
!		PTfcn.f90						essentials.f90
!		gibbsfcn.f90					minf_fcn.f90
!		PTdriver.f90										

!	Record of revisions:
!			Date		Programmer				Description of Change
!			====		==========				=====================
!			8/18/99		P.D. Ting				inception
!			
!			
!	Voo of the first component should always be the largest in this implementation.

use essentials
implicit none
							! (1) for hexane & polyethylene-cotene, 
integer :: switch			! (2) for hexadecane & hexane
							! (3) for ethylene & heptane
							! (4) for methane, CO2 and hexadecane
							! (5) for polyethylene-octene and hexane but with pseudocomponents
							! (6) for polyethylene-octene and octane 
							! (7) for polyethylene-propylene, ethylene, and butene
							! (8) for polyethylene and ethylene
							! (9) for ethylene & polyethylene
							! (10) for hexane & polystyrene
							! (11) ethane, toluene, and polystyrene
							! (13) for methanol & pentane
							! (14) for hexane & polystyrene with association on Pstyrene
							! (15) for asphaltene and hydrocarbons
							! (21) asphaltene(1) and propane(2)
							! (20) asphaltene(1) and butane(2)
							! (19) asphaltene(1) and pentane(2)
							! (18) asphaltene(1) and hexane(2)
							! (17) asphaltene(1) and heptane(2)
							! (16) asphaltene(1) and decane(2)
							! (15) asphaltene(1) and hexadecane(2)
							! (25) asphaltene(1) and octacosane(2)
							! (26) benzene (1) and toluene(2)
							! (27) hexane(1) and toluene(2) PCSAFT PARAMETERS
							! (28) hexane(1) and toluene(2) HR parameters
							! (29) Methane(1) and hexadecane(2) PCSAFT
							! (30) " tetradecane
							! (31) " dodecane
							! (32) " decane
							! (33) " nonane
							! (34) " octane
							! (35) " heptane
							! (36) " hexane
							! (37)  " pentane
							! (38) CO(1) and hexane(2) PCSAFT
							! (39) " heptane
							! (40) Ethane(1) and hexane(2) PCSAFT  
							! (41) " heptane 
							! (42) " octane
							! (43) " nonane 
							! (44) " decane 
							! (45) " dodecane
							! (46) " tetradecane
							! (47) " hexadecane
							! (48) CO(1) and octane (2) PCSAFT
							! (49) " nonane
							! (50) " decane
							! (51) " dodecane
							! (52) " tetradecane
							! (53) " hexadecane
							! (54) " methane
							! (55) H2(1) and  hexane(2) PCSAFT
							! (56) " heptane 
							! (57) " octane
							! (58) " nonane
							! (59) " decane
							! (60) " dodecane
							! (61) " tetradecane
							! (62) " hexadecane
							! (63) H2(1) and butene(2) PCSAFT
							! (64) " pentene
							! (65) " hexene
							! (66) " octene
							! (67)	H2(1) and C-100 alkane (2) PCSAFT
							! (68)  CO			"
							! (69)	ethane		"
							! (70)  methane		"
							! (71)	pentane and methanol
							! (72) H2(1) and hexadecene(2) PCSAFT
							! (73) "	tetradecene
							! (74) "	dodecene
							! (75) "	decene
							! (76) "	nonene
							! (77) "	heptene
							! (78) C0(1) and hexadecene(2) PCSAFT
							! (79) "	tetradecene
							! (80) "	dodecene
							! (81) "	decene
							! (82) "	nonene
							! (83) "	octene
							! (84) "	heptene
							! (85) Methane(1) and hexadecene(2) PCSAFT
							! (86) "	tetradecene
							! (87) "	dodecene
							! (88) "	decene
							! (89) "	nonene
							! (90) "	octene
							! (91) "	heptene
							! (92) Ethane(1) and hexadecene(2) PCSAFT
							! (93) "	tetradecene
							! (94) "	dodecene
							! (95) "	decene
							! (96) "	nonene
							! (97) "	octene
							! (98) "	heptene
							! (99) Methane(1) and nonanol(2) HR (w/o dipolar contribution)
							! (100) H2(1) and C-16.5 alkene (2)
							! (101) H2(1) and correlated alkane parameters PC SAFT
							! (102) Methanol (1) and n-butanol(2) ! PC SAFT
							! (103) Methane (1) and Hexane (2)
							! (104) Methanol (1) and cyclohexane (2) ! PC SAFT
							! (105) Methanol (1) and cyclohexane (2) HR
							! (106) Methanol and butane (2) PC WITH DIPOLE
							! (107) Methanol and isobutane (2) PC NO dipole
							! (108) Methanol (1) and N- butane(2) PC NO dipole
							! (109) Methanol (1) and Methane  (2) PC NO dipole
							! (110) Methanol (1) and Ethane   (2) PC NO dipole
							! (111) Methanol (1) and Propane  (2) PC NO dipole
							! (112) Methanol (1) and N-Hexane (2) PC NO dipole
							! (113) Methanol (1) and n-Butane (2) PC NO dipole
							! (114) Methanol (1) and n-Pentane(2) PC NO dipole
							! (115) Methanol (1) and N-Hexane (2) PC NO dipole
							! (116) Methanol (1) and n-heptane(2) PC NO dipole
							! (117) Methanol (1) and n-octane (2) PC NO dipole
							! (118) CO2		 (1) and Methane  (2) PC NO dipole
							! (119) Water    (1) and Methane  (2) PC NO Dipole
							! (120) Water    (1) and Ethane   (2) PC NO Dipole
							! (121) ethanol  (1) and Co2      (2) PC NO Dipole		
							! (122) C02      (1) and N-Pentane(2) PC NO Dipole

							!(300) Methanol (1) and Butane  (2) HR Saft
							!(301) Methanol (1) and Pentane (2) HR Saft
							!(302) Methanol (1) and Hexane  (2) HR Saft
							!(303) Methanol (1) and Heptane (2) HR Saft
							!(304) Methanol (1) and Octane  (2) HR Saft
							!(305) Methanol (1) and nonane  (2) HR Saft
							!(306) Methanol (1) and decane  (2) HR Saft
							!(307) Methanol (1) and decane  (2) HR Saft
							!(308) Methanol (1) and decane  (2) HR Saft

							!(607) ethane (1) and      C02  (2) PC Saft

							!(700) Methane(1) and CO2 (2) PPC-SAFT
						
!	Note that e_ii differs from 10 for: argon, methane, ammonia, water, nitrogen, CO, 
!		chlorine, CS2, CO2, SO2.  

integer :: i,j,a,b
real(kind=double) :: kij_input


! assignment starts here and are initialized by the module ESSENTIALS already
!	Assigning SAFT initial & input values


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0d0
	kij_tmp(2,1) = 0.0d0
	kij_tmp(2,2) = 0.0d0

	
	N_sites_tmp(1) = 0 
	N_sites_tmp(2) = 0
write (6,*) ' which system to model'
read (5,*) switch
write (6,*) switch

write(6,*) 'Enter the Kij factor'
read(5,*) kij_input
write(6,*) kij_input


!!!!!!!!!!!!!!!!!!!! This switch sets the system to be used. If adding a new system, the 
!syntax is :
! ncp = number of components as INTEGER
! status11 = hydrogen bonding switch as INTEGER
! TURN THIS OFF IF no hyrogen bonding or acids present in system. 
! Failure to do this will give you error messages up the Wazoo. 
! PC_dispersion = dispersion switch as INTEGER
! v00_tmp(component as INTEGER) = volume as REAL, DOUBLE PRECISION
! u0_tmp(Component as INTEGER, Component as INTEGER) = as REAL, DOUBLE PRECISION
! m_tmp(component as INTEGER) as REAL, DP
! e_ii_tmp(component as INTEGER) as REAL, double precision from 1 to 10. Normally 10

! N_sites_tmp(component as INTEGER) as INTEGER
! fa_tmp(component as Integer, site as Integer, component as Integer, site as integer,2) as REAL, DP
! kappa_tmp(component as Integer, site as Integer, component as Integer, site as integer,2) as REAL, DP

!Kij_tmp(component as Integer, component as Integer) 

! This is added to prevent any possible mishaps with the association variables

if (switch.eq.700) then
! PC SAFT  with polar contribution parameters. 
	ncp = 2 
	status11 = 0
	PC_dispersion = 1
	analytic_flag = 0
	polar_flag = 1

! Methane (1) 
	v00_tmp(1) =   3.7039**3*3.141592654*0.602252/6.0/0.7404804897 
	u0_tmp(1,1) = 150.03d0  
	m_tmp(1) = 1.00d0   
	
	N_sites_tmp(1) = 0

	Q_tmp(1) = 0.0d0
	xq_tmp(1) =0.0d0
	xd_tmp(1)= 0.00d0
	mu_tmp(1) = 0.00d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! c02 (2) Fitted to IUPAC CO2 Pvap data from 218 to 304 K
!	Int'l thermo. tables of the fluid state: CO2 Pergamon press
	v00_tmp(2)  =  8.819D0
	m_tmp(2)    =  2.049D0
	u0_tmp(2,2) =  165.51d0
 
	N_sites_tmp(2) = 0
	
	Q_tmp(2) = 4.1d0
	xq_tmp(2) =0.1d0
	xd_tmp(2)= 0.0d0
	mu_tmp(2) = 0.0d0
			
else if (switch.eq.607) then
! PC SAFT  without polar contribution parameters. 
! note  turn off hydrogen bonding parameters (status 11) if 
	ncp = 2 
	status11 = 0
	PC_dispersion = 1
	analytic_flag = 0
	polar_flag = 0

! ethane (1) non polar for now	
	v00_tmp(1) =   3.5206**3*3.141592654*0.602252/6.0/0.7404804897 
	u0_tmp(1,1) = 191.42d0  
	m_tmp(1) = 1.6069d0    
	
	N_sites_tmp(1) = 0

	Q_tmp(1) = 0.0d0
	xq_tmp(1) =0.0d0
	xd_tmp(1)= 0.00d0
	mu_tmp(1) = 0.00d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! c02 (2) Taken from Gross and sadowski

	v00_tmp(2)  =  2.7852**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(2)    =  2.0729d0
	u0_tmp(2,2) =  169.21d0
 
	N_sites_tmp(2) = 0
	
	Q_tmp(2) = 0.0d0
	xq_tmp(2) =0.0d0
	xd_tmp(2)= 0.0d0
	mu_tmp(2) = 0.0d0		


else if (switch.eq.300) then
! METHANOL Butane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	analytic_flag=1
	PC_dispersion=0

	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Butane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.599
	m_tmp(2)    =  3.458
	u0_tmp(2,2) =  195.11
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0


else if (switch.eq.301) then
! METHANOL Pentane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
	
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00
	mw_tmp(1) = 32.04

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Pentane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.533d0
	m_tmp(2)    =  4.091d0
	u0_tmp(2,2) =  200.02d0
	e_ii_tmp(2)= 10.00
	mw_tmp(2) = 72.15

	N_sites_tmp(2) = 0

else if (switch.eq.302) then
! METHANOL Hexane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11 = 1
	PC_dispersion = 0
	analytic_flag =1
	polar_flag = 0
	
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13d0
	m_tmp(1) = 1.776d0
	e_ii_tmp(1)= 10.00d0

	N_sites_tmp(1) = 2

		
	Q_tmp(1) = 0.0d0
	xq_tmp(1) =0.0d0
	xd_tmp(1)= 0.0d0
	mu_tmp(1) = 0.0d0


	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856d0
	kappa_tmp(1,1,2,1) = 0.04856d0
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Hexane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.475d0
	m_tmp(2)    =  4.724d0
	u0_tmp(2,2) =  202.72d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0
	
	Q_tmp(2) = 0.0d0
	xq_tmp(2) =0.0d0
	xd_tmp(2)= 0.0d0
	mu_tmp(2) = 0.0d0


else if (switch.eq.303) then
! METHANOL Heptane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
	
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Heptane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.282d0
	m_tmp(2)    =  5.391d0
	u0_tmp(2,2) =  204.61d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0



else if (switch.eq.304) then
! METHANOL OCTANE HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
		
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Octane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.234d0
	m_tmp(2)    =  6.045d0
	u0_tmp(2,2) =  206.03d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0


else if (switch.eq.305) then
! METHANOL Nonane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
		
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! nonane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  12.240d0
	m_tmp(2)    =  6.883d0
	u0_tmp(2,2) =  203.56d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0

else if (switch.eq.306) then
! METHANOL Decane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
	
		
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! decane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  11.723d0
	m_tmp(2)    =  7.527d0
	u0_tmp(2,2) =  205.46d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0

else if (switch.eq.307) then
! METHANOL dodecane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
		
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! dodecane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  11.864d0
	m_tmp(2)    =  8.921d0
	u0_tmp(2,2) =  205.93d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0
! BEGIN PC SAFT PARAMETERS

else if (switch.eq.308) then
! METHANOL Propane HR SAFT Non Polar
! METHANOL (1) FROM HR
	ncp = 2 
	status11=1
	PC_dispersion=0
	analytic_flag=1
		
	v00_tmp(1) = 12.0d0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1)= 10.00

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Propane (2) Taken from HR IECR v29 no 11 1990 1289

	v00_tmp(2)  =  13.457
	m_tmp(2)    =  2.696d0
	u0_tmp(2,2) =  193.03d0
	e_ii_tmp(2)= 10.00

	N_sites_tmp(2) = 0
! BEGIN PC SAFT PARAMETERS
else if (switch.eq.122) then
! C02 -N pentane PC SAFT, non polar
! c02 (1) FROM I&EC V41 no 22 2002
	ncp = 2 
	status11=0
	PC_dispersion=1
	analytic_flag=0
	
	v00_tmp(1) = 2.7852**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 169.21d0
	m_tmp(1) = 2.0729d0	

	N_sites_tmp(1) = 0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 0.0d0
	fa_tmp(1,1,2,1,2) = 0.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.0d0
	kappa_tmp(1,1,2,1) = 0.0d0
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

!  n-pentane (2) Taken from Sadowski IECR V 40, no 4, 1248
	
	v00_tmp(2)  =  3.7729**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  2.6896d0
	u0_tmp(2,2) =  231.20d0 

	N_sites_tmp(2) = 0 
	
else if (switch.eq.121) then
! Ethanol-C02 PC SAFT, non polar
! Ethanol (1) FROM I&EC V41 no 22 2002
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.1771**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 198.24d0
	m_tmp(1) = 2.3827d0
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2653.4d0
	fa_tmp(1,1,2,1,2) = 2653.4d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.032384d0
	kappa_tmp(1,1,2,1) = 0.032384d0
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! C02 (2) Taken from Sadowski IECR V 40, no 4, 1248
	
	v00_tmp(2)  =  2.7852**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  2.0729d0
	u0_tmp(2,2) =  169.21d0 
	N_sites_tmp(2) = 0

else if (switch.eq.120) then
! Water Methane PC SAFT, non polar
! Methane (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.0007**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 150.03d0
	m_tmp(1) = 1.0656d0
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2500.7d0
	fa_tmp(1,1,2,1,2) = 2500.7d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.034868d0
	kappa_tmp(1,1,2,1) = 0.034868d0
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! methane (2) Taken from Sadowski IECR V 40, no 4, 1248
	
	v00_tmp(2) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 150.03
	m_tmp(2) = 1.0000

else if (switch.eq.119) then
! METHANOL Decane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Nonane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.8384**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  4.6627d0
	u0_tmp(2,2) =  243.87d0 

	N_sites_tmp(2) = 0

else if (switch.eq.118) then
! METHANOL Nonane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Nonane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.8448**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  4.2709d0
	u0_tmp(2,2) =  244.51d0 

	N_sites_tmp(2) = 0


else if (switch.eq.117) then
! METHANOL n-Octane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Octane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.8373**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  3.8176d0
	u0_tmp(2,2) =  242.78d0 

	N_sites_tmp(2) = 0


else if (switch.eq.116) then
! METHANOL Heptane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Heptane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.8049**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  3.4831d0
	u0_tmp(2,2) =  238.40d0 

	N_sites_tmp(2) = 0

else if (switch.eq.115) then
! METHANOL Hexane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1

	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	
	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Hexane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.7983**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  3.0576d0
	u0_tmp(2,2) =  236.77d0 

	N_sites_tmp(2) = 0


 else if (switch.eq.114) then
! METHANOL PENTANE PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1
	
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Pentane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.7729**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  2.6896d0
	u0_tmp(2,2) =  231.20d0 

	N_sites_tmp(2) = 0

else if (switch.eq.113) then
! METHANOL Butane PC SAFT Non Polar
! METHANOL (1) FROM SADOWSKIS PAPER
	ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1

	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.0d0

! KIJ  
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Butane (2) Taken from Sadowski IECR V 40, no 4, 1248

	v00_tmp(2)  =  3.7086**3*3.141592654*0.602252/6.0/0.7404804897 
	m_tmp(2)    =  2.3316d0
	u0_tmp(2,2) =  222.88d0 

	N_sites_tmp(2) = 0

elseif (switch.eq.112) then
! Parameters for PC saft system of Methanol (1) and Propane (2) 
! PC SAFT with no Dipole contribution. 
! Methanol

    ncp = 2 
	status11=1
	PC_dispersion=1
	analytic_flag=1

	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90d0
	m_tmp(1) = 1.5255d0
	

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176d0
	kappa_tmp(1,1,2,1) = 0.035176d0
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! propane From IECR V 40 no 4 2001
	v00_tmp(2) = 3.6184**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(2) = 2.002
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 208.11

else if (switch.eq.110) then
! Parameters for PC saft system of Methanol (1) and Ethane (2) 
! PC SAFT with no Dipole contribution. 
! Methanol
	v00_tmp(1) = 3.2300*3.8499**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5
	fa_tmp(1,1,2,1,2) = 2899.5
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.00


		kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Ethane From IECR V 40 no 4 2001
	
	m_tmp(2) = 1.6069
	v00_tmp(2) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 191.42

else if (switch.eq.109) then
! Parameters for PC saft system of Methanol (1) and Methane (2) 
! PC SAFT with no Dipole contribution. 
! Methanol From sadowski's paper
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5
	fa_tmp(1,1,2,1,2) = 2899.5
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.00


		kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! methane From IECR V 40 no 4 2001
	
	m_tmp(2) = 1.0000
	v00_tmp(2) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 150.03

else if (switch.eq.108) then
! Parameters for PC saft system of methanol (1) and N butane (2) 
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255d0
	

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! n-butane From IECR V 40 no 4 2001
	
	m_tmp(2) = 2.3316
	v00_tmp(2) = 3.7086**3*3.141592654*0.602252/6.0/0.7404804897
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 222.88

else if (switch.eq.107) then
! Parameters for PC saft system of Methanol (1) and Isobutane (2) 
! PC SAFT with no Dipole contribution. 
! Methanol
	v00_tmp(1) = 3.2300**3*3.141592654*0.602252/6.0/0.7404804897
	u0_tmp(1,1) = 188.90
	m_tmp(1) = 1.5255
	

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.5d0
	fa_tmp(1,1,2,1,2) = 2899.5d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Ethane From IECR V 40 no 4 2001
	
	m_tmp(2) = 2.2616
	v00_tmp(2) = 3.7574*3.8499**3*3.141592654*0.602252/6.0/0.7404804897
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 216.53

else if (switch.eq.106) then
! Parameters for PC saft system of Methanol (1) and Butane (2) 
!PC SAFT, parameters taken from Appendix B NEW PC SAFT PARAMETERS
! Methanol
	v00_tmp(1) = 8.763
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 2.6500
	!e_ii_tmp(1) = 10.00

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 1653.03
	fa_tmp(1,1,2,1,2) = 1653.03
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.3639
	kappa_tmp(1,1,2,1) = 0.3639
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = kij_input
	kij_tmp(2,1) = kij_input
	kij_tmp(2,2) = 0.0d0

! Butane From Appendix B New PC SAFT parameters
	v00_tmp(2) = 20.580
	m_tmp(2) = 2.2864
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 222.00
	!e_ii_tmp(2)= 10.00



elseif (switch.eq.105) then
! these parameters are for a HR SAFT system of Methanol (1) and Cyclohexane(2)
! Methanol Parameters from ind. Eng. Chem Res. Vol 29. No. 11. 1990
	v00_tmp(1) = 12.0
	u0_tmp(1,1) = 216.13
	m_tmp(1) = 1.776
	e_ii_tmp(1) = 10.00

	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2714.0d0
	fa_tmp(1,1,2,1,2) = 2714.0d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.04856
	kappa_tmp(1,1,2,1) = 0.04856
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.044
	kij_tmp(2,1) = 0.044
	kij_tmp(2,2) = 0.0d0

! Cyclohexane Parameters. Same source as methanol
	v00_tmp(2) = 13.502
	m_tmp(2) = 3.970
	N_sites_tmp(2) = 0
	u0_tmp(2,2) = 236.41
	e_ii_tmp(2)= 10.00


elseif (switch.eq.104) then

! These parameters are for a PC SAFT sysyem of  Cyclohexane (2) and Methanol(1)

! Cyclohexane taken from Ind Chem. Res. V. 40 no 4, 2001
v00_tmp(2) = 3.8499**3*3.141592654*0.602252/6.0/0.7404804897
m_tmp(2) = 2.5303
N_sites_tmp(2) = 0
u0_tmp(2,2) = 278.11

! Methanol taken from sadowski's paper, unpublished. 
	 v00_tmp(1) = 3.23**3*3.141592654*0.602252/6.0/0.7404804897
	 u0_tmp(1,1) = 188.90
	 m_tmp(1) = 1.5255
	 !e_ii_tmp(1) = 10.00
! Methanol Association Parameters	 
	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2899.50d0
	fa_tmp(1,1,2,1,2) = 2899.50d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.00
	kappa_tmp(1,1,1,2) = 0.035176
	kappa_tmp(1,1,2,1) = 0.035176
	kappa_tmp(1,1,2,2) = 0.00


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.051
	kij_tmp(2,1) = 0.051
	kij_tmp(2,2) = 0.0d0
else if (switch.eq.103) then

! Methane (1) and Hexane (2)
! Methane Volume Segment

v00_tmp(1)=21.576
m_tmp(1)=1.0	
u0_tmp(1,1)=190.29
! These values came from Haung and Razsdoz, Ind. Engr Chem Res. V29.11.1990
	
! Hexane Volume segment
v00_tmp(2)=12.475	
m_tmp(2)=4.724	
u0_tmp(2,2)=202.72

! Fudge Factors
kij_tmp(1,1) = 0.0d0
kij_tmp(1,2) = 0.052
kij_tmp(2,1) = 0.052
kij_tmp(2,2) = 0.0d0

! E parameters
e_ii_tmp(1) = 1.0d0
e_ii_tmp(2) = 10.0d0




else if (switch.eq.102) then

!  N-butanol (1) Methanol (2) and		!!!!!!!!!!!!!!!!!!!!!!PC SAFT!!!!!!!!!!!!!!!!!!!!!!!!
! 1-butanol segment parameters
	 v00_tmp(1) = 3.6139**3*3.141592654*0.602252/6.0/0.7404804897
	 u0_tmp(1,1) = 259.59
	 m_tmp(1) = 2.7515
	 
! 1-butanol Association paramaeters
	N_sites_tmp(1) = 2
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 2544.60d0
	fa_tmp(1,1,2,1,2) = 2544.60d0
	fa_tmp(1,1,2,2,2) = 0.0d0
	
	kappa_tmp(1,1,1,1) = 0.0d0
	kappa_tmp(1,1,1,2) = 0.006692
	kappa_tmp(1,1,2,1) = 0.006692
	kappa_tmp(1,1,2,2) = 0.0d0

! Methanol Volume Segment
! These were taken from J gross, G sadowski "Application of PC saft to associating systems"
! Unpublished paper, Table 1
	 v00_tmp(2) = 3.23**3*3.141592654*0.602252/6.0/0.7404804897
	 u0_tmp(2,2) = 188.90
	 m_tmp(2) = 1.5255
	 !e_ii_tmp(1) = 10.00
! Methanol Association Parameters	 
	N_sites_tmp(2) = 2
	fa_tmp(2,2,1,1,2) = 0.0d0
	fa_tmp(2,2,1,2,2) = 2899.50d0
	fa_tmp(2,2,2,1,2) = 2899.50d0
	fa_tmp(2,2,2,2,2) = 0.0d0
	
	kappa_tmp(2,2,1,1) = 0.00
	kappa_tmp(2,2,1,2) = 0.035176
	kappa_tmp(2,2,2,1) = 0.035176
	kappa_tmp(2,2,2,2) = 0.00

! Methanol-Butanol Association Parameters
	fa_tmp(2,1,1,1,2) = 0.0d0
	fa_tmp(2,1,1,2,2) = 2722.05d0
	fa_tmp(2,1,2,1,2) = 2722.05d0
	fa_tmp(2,1,2,2,2) = 0.0d0
	
	kappa_tmp(2,1,1,1) = 0.00
	kappa_tmp(2,1,1,2) = 0.015343
	kappa_tmp(2,1,2,1) = 0.015343
	kappa_tmp(2,1,2,2) = 0.00

! Butanol-Methanol Association Parameters
	fa_tmp(1,2,1,1,2) = 0.0d0
	fa_tmp(1,2,1,2,2) = 2722.05d0
	fa_tmp(1,2,2,1,2) = 2722.05d0
	fa_tmp(1,2,2,2,2) = 0.0d0
	
	kappa_tmp(1,2,1,1) = 0.00
	kappa_tmp(1,2,1,2) = 0.015343
	kappa_tmp(1,2,2,1) = 0.015343
	kappa_tmp(1,2,2,2) = 0.00

	
!e_ii_tmp(1) = 10.0d0
!e_ii_tmp(2) = 10.0d0


else if (switch.eq.101) then

do

!ethane

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	


!methane

v00_tmp(2)=3.7039	
m_tmp(2)=0.99996019	
u0_tmp(2,2)=150.03


!ethane

v00_tmp(2)=3.531812925	
m_tmp(2)=1.575318146	
u0_tmp(2,2)=186.4470134


!propane

v00_tmp(2)=3.618346024	
m_tmp(2)=2.001817216	
u0_tmp(2,2)=208.1076225

!butane

v00_tmp(2)=3.694349663
m_tmp(2)=2.387267339	
u0_tmp(2,2)=221.0762767

exit
!pentane

v00_tmp(2)=3.751273396
m_tmp(2)=2.755492642	
u0_tmp(2,2)=229.5918428

!hexane

v00_tmp(2)=3.794182099	
m_tmp(2)=3.115164226	
u0_tmp(2,2)=235.5920239


!heptane

v00_tmp(2)=3.82730659	
m_tmp(2)=3.46962545
u0_tmp(2,2)=240.0370294


!octane

v00_tmp(2)=3.853541368	
m_tmp(2)=3.820927294
u0_tmp(2,2)=243.4609078



end do


else if (switch.eq.100) then

! H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775	

! C-16.5 alkene (mixture of C15 - C18 alkenes)

	v00_tmp(2) = 26.6842781	!pcsaft
	m_tmp(2) = 6.62365	 
	u0_tmp(2,2) = 257.9692727
	


else if(switch.eq.99) then



!methane

	v00_tmp(1) = 21.576	!HR
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 190.29

! 1-nonanol

	v00_tmp(2)=12.0	!HR
	m_tmp(2)=7.322
	u0_tmp(2,2)=219.18

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 2
	
	fa_tmp(2,2,1,1,2) = 0.0d0
	fa_tmp(2,2,1,2,2) = 2516
	fa_tmp(2,2,2,1,2) = 2516
	fa_tmp(2,2,2,2,2) = 0.0d0
	
	kappa_tmp(2,2,1,1) = 0.0d0
	kappa_tmp(2,2,1,2) = 2.249e-2
	kappa_tmp(2,2,2,1) = 2.249e-2
	kappa_tmp(2,2,2,2) = 0.0d0


else if (switch.eq.98) then

	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	
	
	!heptene

	m_tmp(2) = 3.3637
	v00_tmp(2) = 23.168
	u0_tmp(2,2) = 240.6174


else if (switch.eq.97) then

	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	
	
	!octene

	v00_tmp(2) = 3.8133**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.7424	  
	u0_tmp(2,2) = 243.02

else if (switch.eq.96) then


	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	!nonene
	m_tmp(2) = 3.99
	v00_tmp(2) = 24.7593
	u0_tmp(2,2) = 249.27

else if (switch.eq.95) then


	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	!decene	
	m_tmp(2) = 4.37
	v00_tmp(2) = 25.07
	u0_tmp(2,2) = 250.35

else if (switch.eq.94) then


	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	!dodecene	
	m_tmp(2) = 4.988
	v00_tmp(2) = 26.172
	u0_tmp(2,2) = 255.14

else if (switch.eq.93) then


	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	!tetradecene
	m_tmp(2) = 5.7437
	v00_tmp(2) = 26.432
	u0_tmp(2,2) = 256.657

else if (switch.eq.92) then

	!ethane(1) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	!hexadecene
	m_tmp(2) = 6.5
	v00_tmp(2) = 26.73
	u0_tmp(2,2) = 256.7



else if (switch.eq.91) then

	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03
	
	!heptene

	m_tmp(2) = 3.3637
	v00_tmp(2) = 23.168
	u0_tmp(2,2) = 240.6174


else if (switch.eq.90) then

	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03
	
	!octene

	v00_tmp(2) = 3.8133**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.7424	  
	u0_tmp(2,2) = 243.02

else if (switch.eq.89) then


	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03

	!nonene
	m_tmp(2) = 3.99
	v00_tmp(2) = 24.7593
	u0_tmp(2,2) = 249.27

else if (switch.eq.88) then


	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03

	!decene	
	m_tmp(2) = 4.37
	v00_tmp(2) = 25.07
	u0_tmp(2,2) = 250.35

else if (switch.eq.87) then


	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03

	!dodecene	
	m_tmp(2) = 4.988
	v00_tmp(2) = 26.172
	u0_tmp(2,2) = 255.14

else if (switch.eq.86) then


	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03

	!tetradecene
	m_tmp(2) = 5.7437
	v00_tmp(2) = 26.432
	u0_tmp(2,2) = 256.657

else if (switch.eq.85) then

	!methane(1) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897
	m_tmp(1) = 0.9999 
	u0_tmp(1,1) = 150.03

	!hexadecene
	m_tmp(2) = 6.5
	v00_tmp(2) = 26.73
	u0_tmp(2,2) = 256.7

else if (switch.eq.84) then

	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	
	
	!heptene
	m_tmp(2) = 3.3637
	v00_tmp(2) = 23.168
	u0_tmp(2,2) = 240.6174


else if (switch.eq.83) then

	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	
	
	!octene

	v00_tmp(2) = 3.8133**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.7424	  
	u0_tmp(2,2) = 243.02

else if (switch.eq.82) then


	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	

	!nonene
	m_tmp(2) = 3.99
	v00_tmp(2) = 24.7593
	u0_tmp(2,2) = 249.27

else if (switch.eq.81) then


	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	

	!decene	
	m_tmp(2) = 4.37
	v00_tmp(2) = 25.07
	u0_tmp(2,2) = 250.35

else if (switch.eq.80) then


	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	

	!dodecene	
	m_tmp(2) = 4.988
	v00_tmp(2) = 26.172
	u0_tmp(2,2) = 255.14

else if (switch.eq.79) then


	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	

	!tetradecene
	m_tmp(2) = 5.7437
	v00_tmp(2) = 26.432
	u0_tmp(2,2) = 256.657

else if (switch.eq.78) then

	!CO(1) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15	

	!hexadecene
	m_tmp(2) = 6.5
	v00_tmp(2) = 26.73
	u0_tmp(2,2) = 256.7

else if (switch.eq.77) then

	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775
	
	!heptene
	m_tmp(2) = 3.3637
	v00_tmp(2) = 23.168
	u0_tmp(2,2) = 240.6174

else if (switch.eq.76) then


	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

	!nonene
	m_tmp(2) = 3.99
	v00_tmp(2) = 24.7593
	u0_tmp(2,2) = 249.27

else if (switch.eq.75) then


	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

	!decene	
	m_tmp(2) = 4.37
	v00_tmp(2) = 25.07
	u0_tmp(2,2) = 250.35

else if (switch.eq.74) then


	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

	!dodecene	
	m_tmp(2) = 4.988
	v00_tmp(2) = 26.172
	u0_tmp(2,2) = 255.14

else if (switch.eq.73) then


	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

	!tetradecene
	m_tmp(2) = 5.7437
	v00_tmp(2) = 26.432
	u0_tmp(2,2) = 256.657

else if (switch.eq.72) then

	!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

	!hexadecene
	m_tmp(2) = 6.5
	v00_tmp(2) = 26.73
	u0_tmp(2,2) = 256.7

else if (switch.eq.71) then

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	 
	u0_tmp(1,1) = 150.03


	v00_tmp(2) = 27.24	!pcsaft
	m_tmp(2) = 3.9417  
	u0_tmp(2,2) = 277.876


	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 2
	
	fa_tmp(2,2,1,1,2) = 0.0d0
	fa_tmp(2,2,1,2,2) = 2714.0d0
	fa_tmp(2,2,2,1,2) = 2714.0d0
	fa_tmp(2,2,2,2,2) = 0.0d0
	
	kappa_tmp(2,2,1,1) = 0.01593
	kappa_tmp(2,2,1,2) = 0.04856
	kappa_tmp(2,2,2,1) = 0.04856
	kappa_tmp(2,2,2,2) = 0.01593

else if (switch.eq.70) then

!	methane(1) and C-100 alkane(2)

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	 
	u0_tmp(1,1) = 150.03


	v00_tmp(2) = 4.05**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 35.33	  
	u0_tmp(2,2) = 267.42

else if (switch.eq.69) then

! ethane(1) and C-100 alkane(2)

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  
	u0_tmp(1,1) = 191.42	

	v00_tmp(2) = 4.05**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 35.33	  
	u0_tmp(2,2) = 267.42


else if (switch.eq.68) then

!	CO(1)  and C-100 alkane(2)

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	 
	u0_tmp(1,1) = 92.15		


	v00_tmp(2) = 4.05**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 35.33	  
	u0_tmp(2,2) = 267.42

else if (switch.eq.67) then

!	H2(1) and C-100 alkane(2)

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775	


	v00_tmp(2) = 4.05**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 35.33	  
	u0_tmp(2,2) = 267.42

!! mole fraction = 2.76e-6   mass fraction = 1.9e-3

else if (switch.eq.66) then

!H2
	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775	

!octene

	v00_tmp(2) = 3.8133**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.7424	  
	u0_tmp(2,2) = 243.02

else if(switch.eq.65) then

!H2

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

!hexene

	v00_tmp(2) = 3.7753**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 2.9853	  
	u0_tmp(2,2) = 236.81

else if(switch.eq.64) then

!H2

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

!pentene
	v00_tmp(2) = 3.7399**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 2.6006	  
	u0_tmp(2,2) = 231.99


else if (switch.eq.63) then

!H2

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775

!butene

	v00_tmp(2) = 3.6431**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 2.2864	  
	u0_tmp(2,2) = 222.0
		

else if (switch.eq.62) then

!	H2(1) hexadecane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	 
	u0_tmp(1,1) = 19.2775	

	v00_tmp(2) = 3.9552**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 6.648	  
	u0_tmp(2,2) = 254.70	

else if (switch.eq.61) then

!	H2(1) tetradecane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	v00_tmp(2) = 3.9396**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.9	  !pcsaft
	u0_tmp(2,2) = 254.21	!pcsaft


else if (switch.eq.60) then

!	H2(1) dodecane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	v00_tmp(2) = 3.8959**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.306	  !pcsaft
	u0_tmp(2,2) = 249.21	!pcsaft


else if (switch.eq.59) then

!	H2(1) decane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	v00_tmp(2) = 3.8384**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.663	  !pcsaft
	u0_tmp(2,2) = 243.87	!pcsaft


else if (switch.eq.58) then

!	H2(1) nonane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	v00_tmp(2) = 3.8448**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.2		  !pcsaft
	u0_tmp(2,2) = 244.51	!pcsaft


else if (switch.eq.57) then

!	H2(1) octane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	v00_tmp(2) = 3.8373**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.8176	  !pcsaft
	u0_tmp(2,2) = 242.78	!pcsaft


else if (switch.eq.56) then

!	H2(1) heptane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	
	v00_tmp(2) = 3.8049**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.483	  !pcsaft
	u0_tmp(2,2) = 238.40	!pcsaft


else if (switch.eq.55) then

!	H2(1) hexane (2) 

	v00_tmp(1) = 11.336	!pcsaft
	m_tmp(1) = 1.000	  !pcsaft
	u0_tmp(1,1) = 19.2775	!pcsaft

	m_tmp(2) = 3.0576	  !pcsaft
	v00_tmp(2) = 3.7983**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	u0_tmp(2,2) = 236.77	!pcsaft

else if (switch.eq.54) then

!	CO(1)  methane(2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 0.9999	  !pcsaft
	u0_tmp(2,2) = 150.03	!pcsaft

else if (switch.eq.53) then

!	CO(1) hexadecane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.9552**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 6.648	  !pcsaft
	u0_tmp(2,2) = 254.70	!pcsaft


else if (switch.eq.52) then

!	CO(1) tetradecane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.9396**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.9	  !pcsaft
	u0_tmp(2,2) = 254.21	!pcsaft

else if (switch.eq.51) then

!	CO(1) dodecane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.8959**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.306	  !pcsaft
	u0_tmp(2,2) = 249.21	!pcsaft


else if (switch.eq.50) then

!	CO(1) decane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.8384**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.663	  !pcsaft
	u0_tmp(2,2) = 243.87	!pcsaft

else if (switch.eq.49) then

!	CO(1) nonane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.8448**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.2		  !pcsaft
	u0_tmp(2,2) = 244.51	!pcsaft

else if (switch.eq.48) then

!	CO(1) octane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.8373**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.8176	  !pcsaft
	u0_tmp(2,2) = 242.78	!pcsaft


else if (switch.eq.47) then

!	ethane(1) hexadecane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.9552**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 6.648	  !pcsaft
	u0_tmp(2,2) = 254.70	!pcsaft

else if (switch.eq.46) then

!	ethane(1) tetradecane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.9396**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.9	  !pcsaft
	u0_tmp(2,2) = 254.21	!pcsaft


else if (switch.eq.45) then

!	ethane(1) dodecane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.8959**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.306	  !pcsaft
	u0_tmp(2,2) = 249.21	!pcsaft


else if (switch.eq.44) then

!	ethane(1) decane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.8384**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.663	  !pcsaft
	u0_tmp(2,2) = 243.87	!pcsaft


else if (switch.eq.43) then

!	ethane(1) nonane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.8448**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.2		  !pcsaft
	u0_tmp(2,2) = 244.51	!pcsaft


else if (switch.eq.42) then

!	ethane(1) octane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	v00_tmp(2) = 3.8373**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.8176	  !pcsaft
	u0_tmp(2,2) = 242.78	!pcsaft


else if (switch.eq.41) then

!	ethane(1) heptane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.607	  !pcsaft
	u0_tmp(1,1) = 191.42	!pcsaft

	
	v00_tmp(2) = 3.8049**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.483	  !pcsaft
	u0_tmp(2,2) = 238.40	!pcsaft


else if (switch.eq.40) then

!	ethane(1) hexane (2) 

	v00_tmp(1) = 3.5206**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	v00_tmp(2) = 3.7983**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft

	m_tmp(1) = 1.607	  !pcsaft
	m_tmp(2) = 3.0576	  !pcsaft

	u0_tmp(1,1) = 191.42	!pcsaft
	u0_tmp(2,2) = 236.77	!pcsaft


else if (switch.eq.39) then

!	CO(1) heptane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 1.3097	  !pcsaft
	u0_tmp(1,1) = 92.15		!pcsaft

	v00_tmp(2) = 3.8049**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.483	  !pcsaft
	u0_tmp(2,2) = 238.40	!pcsaft


else if (switch.eq.38) then

!	CO(1) hexane (2) 

	v00_tmp(1) = 3.2507**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	v00_tmp(2) = 3.7983**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft


	m_tmp(1) = 1.3097	  !pcsaft
	m_tmp(2) = 3.0576	  !pcsaft


	u0_tmp(1,1) = 92.15		!pcsaft
	u0_tmp(2,2) = 236.77	!pcsaft


else if (switch.eq.37) then

!	methane(1) pentane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	v00_tmp(2) = 3.7729**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft

	m_tmp(1) = 0.9999	  !pcsaft
	m_tmp(2) = 2.6896	  !pcsaft

	u0_tmp(1,1) = 150.03	!pcsaft
	u0_tmp(2,2) = 231.20	!pcsaft


else if (switch.eq.36) then

!	methane(1) hexane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft
	
	
	v00_tmp(2) = 3.7983**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.0576	  !pcsaft
	u0_tmp(2,2) = 236.77	!pcsaft

else if (switch.eq.35) then

!	methane(1) heptane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft


	v00_tmp(2) = 3.8049**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.483	  !pcsaft
	u0_tmp(2,2) = 238.40	!pcsaft

else if (switch.eq.34) then

!	methane(1) octane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft


	v00_tmp(2) = 3.8373**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 3.8176	  !pcsaft
	u0_tmp(2,2) = 242.78	!pcsaft


else if (switch.eq.33) then

!	methane(1) nonane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft


	v00_tmp(2) = 3.8448**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.2		  !pcsaft
	u0_tmp(2,2) = 244.51	!pcsaft


else if (switch.eq.32) then

!	methane(1) decane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft

	v00_tmp(2) = 3.8384**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 4.663	  !pcsaft
	u0_tmp(2,2) = 243.87	!pcsaft


else if (switch.eq.31) then

!	methane(1) dodecane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft


	v00_tmp(2) = 3.8959**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.306	  !pcsaft
	u0_tmp(2,2) = 249.21	!pcsaft

else if (switch.eq.30) then

!	methane(1) tetradecane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999 !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft

	v00_tmp(2) = 3.9396**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 5.9	  !pcsaft
	u0_tmp(2,2) = 254.21	!pcsaft

!	v00_tmp(1) = 21.576
!	v00_tmp(2) = 12.389

!	m_tmp(1) = 1.000
!	m_tmp(2) = 9.978

!	u0_tmp(1,1) = 190.29
!	u0_tmp(2,2) = 209.40

else if (switch.eq.29) then

!	methane(1) hexadecane (2) 

	v00_tmp(1) = 3.7039**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(1) = 0.9999	  !pcsaft
	u0_tmp(1,1) = 150.03	!pcsaft


	v00_tmp(2) = 3.9552**3*3.141592654*0.602252/6.0/0.7404804897	!pcsaft
	m_tmp(2) = 6.648	  !pcsaft
	u0_tmp(2,2) = 254.70	!pcsaft


else if (switch.eq.28) then

!	hex(1) tol (2) 

	v00_tmp(1) = 13.457	
	v00_tmp(2) =  11.789
	
	m_tmp(1) = 2.696
	m_tmp(2) = 4.373

	N_sites_tmp(1) = 0 
	N_sites_tmp(2) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

	u0_tmp(1,1) = 193.03
	u0_tmp(2,2) = 245.27

	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0


else if (switch.eq.27) then

!	hex(1) tol (2) PCSAFT parameters
	v00_tmp(1) = 3.7169**3*3.141592654*0.602252/6.0/0.7404804897
	v00_tmp(2) =  21.86783981
	m_tmp(1) = 3.0576
	m_tmp(2) = 2.81490755

	N_sites_tmp(1) = 0 
	N_sites_tmp(2) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

	u0_tmp(1,1) = 285.69
	u0_tmp(2,2) = 254.14

	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

else if (switch.eq.26) then
	v00_tmp(1) = 12.282
	v00_tmp(2) = 11.789 
	m_tmp(1) = 5.391
	m_tmp(2) = 4.373

	N_sites_tmp(1) = 0 
	N_sites_tmp(2) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

	u0_tmp(1,1) = 204.61
	u0_tmp(2,2) = 245.27

	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 0.0 
	fa_tmp(1,1,2,1,2) = 0.0
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.0
	kappa_tmp(1,1,2,1) = 0.0
	kappa_tmp(1,1,2,2) = 0.0




else if (switch.eq.25) then

	v00_tmp(1) = 16.0d0
	v00_tmp(2) = 12.0 
	m_tmp(1) = 35
	m_tmp(2) = 19.287

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

	u0_tmp(2,2) = 209.96
	u0_tmp(1,1) = 350.0

	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch.eq.24) then

	v00_tmp(1) = 16.0d0
	v00_tmp(2) = 14.0 
	m_tmp(1) = 35
	m_tmp(2) = 5.391

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

	u0_tmp(2,2) = 204.61
	u0_tmp(1,1) = 350.0

	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0




!	For system asphaltene (1) toluene (2) and decane (3)

else if (switch.eq.23) then

	v00_tmp(1) = 16.0d0
	v00_tmp(2) = 11.789 
	v00_tmp(3) = 11.723
	m_tmp(1) = 35
	m_tmp(2) = 4.373
	m_tmp(3) = 7.527		

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	N_sites_tmp(3) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(1,3) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	kij_tmp(2,3) = 0.0d0
	kij_tmp(3,1) = 0.0d0
	kij_tmp(3,2) = 0.0d0
	kij_tmp(3,3) = 0.0d0

	u0_tmp(3,3) = 205.46
	u0_tmp(2,2) = 245.27
	u0_tmp(1,1) = 350.0

	e_ii_tmp(3) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0



!	Below is the data for asphaltene(1) toluene(2) and heptane(3)
else if (switch.eq.22) then

	v00_tmp(1) = 16.0d0
	v00_tmp(2) = 11.789 
	v00_tmp(3) = 12.282
	m_tmp(1) = 35
	m_tmp(2) = 4.373
	m_tmp(3) = 5.391		

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	N_sites_tmp(3) = 0


	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(1,3) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	kij_tmp(2,3) = 0.0d0
	kij_tmp(3,1) = 0.0d0
	kij_tmp(3,2) = 0.0d0
	kij_tmp(3,3) = 0.0d0

	u0_tmp(3,3) = 204.61
	u0_tmp(2,2) = 245.27
	u0_tmp(1,1) = 350.0

	e_ii_tmp(3) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0

else if (switch .eq. 21) then
!	Below is the data for asphaltene(1) and propane(2)
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 13.457
	m_tmp(1) = 35
	m_tmp(2) = 2.696		! for 13K MW

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 193.03
	u0_tmp(1,1) = 350.0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch .eq. 20) then
!	Below is the data for asphaltene(1) and butane(2)
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 12.599
	m_tmp(1) = 35
	m_tmp(2) = 3.458		! for 13K MW

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 195.11
	u0_tmp(1,1) = 350.0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch .eq. 19) then
!	Below is the data for asphaltene(1) and pentane
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 12.533
	m_tmp(1) = 35
	m_tmp(2) = 4.091		! for 13K MW

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 200.02
	u0_tmp(1,1) = 350.0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch .eq. 18) then
!	Below is the data for asphaltene(1) and hexane
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 12.475
	m_tmp(1) = 35
	m_tmp(2) = 4.724		! for 13K MW

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 202.72
	u0_tmp(1,1) = 350.0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch .eq. 17) then
!	Below is the data for asphaltene(1) and heptane(2)
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 12.282
!	v00_tmp(2) = 14.0d0
!	v00_tmp(2) = 11.50d0
	m_tmp(1) = 35.0
!	m_tmp(2) = 5.391		! for 13K MW
	m_tmp(2) = 6.0

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0

!	u0_tmp(2,2) = 225.0
	u0_tmp(2,2) = 204.61
	u0_tmp(1,1) = 350.0

	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0

	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185

!	fa_tmp(1,1,1,2,2) = 3092.5
!	fa_tmp(1,1,2,1,2) = 3092.5
!	fa_tmp(1,1,1,2,2) = 500
!	fa_tmp(1,1,2,1,2) = 500
!	fa_tmp(1,1,1,2,2) = 10.0
!	fa_tmp(1,1,2,1,2) = 10.0

	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0


else if (switch .eq. 16) then
!	Below is the data for asphaltene(1) and decane
	v00_tmp(1) = 16.0d0 
	v00_tmp(2) = 11.723
	m_tmp(1) = 35
	m_tmp(2) = 7.527		! for 13K MW

	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 205.46
	u0_tmp(1,1) = 350.0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 6185 
	fa_tmp(1,1,2,1,2) = 6185
	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0



else if (switch .eq. 15) then
!	Below is the data for asphaltene(1) and hexadecane
	v00_tmp(1) = 12.0d0 
	v00_tmp(2) = 12.3
	m_tmp(1) = 47.0d0
	m_tmp(2) = 11.209

	u0_tmp(1,1) = 300.0


	N_sites_tmp(1) = 2 
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 210.65
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(1,1,1,1,2) = 0.0d0
	fa_tmp(1,1,1,2,2) = 15700
	fa_tmp(1,1,2,1,2) = 15700

	fa_tmp(1,1,2,2,2) = 0.0d0

	kappa_tmp(1,1,1,1) = 0.0
	kappa_tmp(1,1,1,2) = 0.003149
	kappa_tmp(1,1,2,1) = 0.003149
	kappa_tmp(1,1,2,2) = 0.0





else if (switch .eq. 14) then
!	Below is data for hexane(1) and polystyrene (2)
	v00_tmp(1) = 12.475 
	v00_tmp(2) = 12.0
	m_tmp(1) = 4.724
	m_tmp(2) = 591.727		! for 13K MW

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 2
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0174
	kij_tmp(2,1) = 0.0174
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 226.5
	u0_tmp(1,1) = 202.72
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0
	fa_tmp(2,2,1,1,2) = 0.0d0
	fa_tmp(2,2,1,2,2) = 3256.8d0
	fa_tmp(2,2,2,1,2) = 3256.8d0
!	fa_tmp(2,2,1,2,2) = 2714.0d0
!	fa_tmp(2,2,2,1,2) = 2714.0d0

	fa_tmp(2,2,2,2,2) = 0.0d0
	kappa_tmp(2,2,1,1) = 0.0
	kappa_tmp(2,2,1,2) = 0.04856
	kappa_tmp(2,2,2,1) = 0.04856
	kappa_tmp(2,2,2,2) = 0.0





else if (switch .eq. 13) then
!	Below is data for pentane(1) and methanol(2)
	v00_tmp(1) = 12.533
	u0_tmp(1,1) = 200.02
	v00_tmp(2) = 12.0
	u0_tmp(2,2) = 216.13
	m_tmp(1) = 4.091
	m_tmp(2) = 1.776
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.03
	kij_tmp(2,1) = 0.03
	kij_tmp(2,2) = 0.0d0
	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 2
	fa_tmp(2,2,1,1,2) = 0.0d0
	fa_tmp(2,2,1,2,2) = 2714.0d0
	fa_tmp(2,2,2,1,2) = 2714.0d0
	fa_tmp(2,2,2,2,2) = 0.0d0
	kappa_tmp(2,2,1,1) = 0.01593
	kappa_tmp(2,2,1,2) = 0.04856
	kappa_tmp(2,2,2,1) = 0.04856
	kappa_tmp(2,2,2,2) = 0.01593
	

else if (switch .eq. 12) then
!	Below is data for hexane(1) and polystyrene (2)
	v00_tmp(1) = 12.0
!	m_tmp(1) = 4.724

	m_tmp(1) = 364.1395383	! for 8k MW
	N_sites_tmp(1) = 0
	kij_tmp(1,1) = 0.0d0
	u0_tmp(1,1) = 226.5
	e_ii_tmp(1) = 10.0d0



else if (switch .eq. 10) then
!	Below is data for hexane(1) and polystyrene (2)
	v00_tmp(1) = 12.475 
	v00_tmp(2) = 12.0
!	m_tmp(1) = 4.724
!	m_tmp(2) = 1137.936057	! for 25K MW
	m_tmp(2) = 591.727		! for 13K MW
!	m_tmp(2) = 2275.872		! for 50K MW
	m_tmp(1) = 4.616

!	m_tmp(2) = 364.1395383	! for 8k MW
	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0174
	kij_tmp(2,1) = 0.0174
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 226.5
	u0_tmp(1,1) = 202.72
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0


else if (switch .eq. 11) then
	!	Below is data for ethane(1), toluene(2), and polystyrene(3)

	v00_tmp(1) = 14.46
	v00_tmp(2) = 11.789
	v00_tmp(3) = 12
	m_tmp(1) = 1.941
	m_tmp(2) = 4.373 
	m_tmp(3) = 3095.186			! for 68k MW
!	m_tmp(3) = 364.1395			! for 8000k MW

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	N_sites_tmp(3) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(2,2) = 0.0d0
	kij_tmp(3,3) = 0.0d0

	kij_tmp(1,2) = 0.0
	kij_tmp(2,1) = 0.0

	kij_tmp(1,3) = 0.07
	kij_tmp(3,1) = 0.07

	kij_tmp(2,3) = 0.0
	kij_tmp(3,2) = 0.0

	u0_tmp(1,1) = 191.44
	u0_tmp(2,2) = 245.27
	u0_tmp(3,3) = 226.5
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(3) = 10.0d0


else if (switch .eq. 7) then
!	below is data for ethylene(1), butene(2), and polyethylene-propylene (3)
	v00_tmp(1) = 18.157
	v00_tmp(2) = 13.154
	v00_tmp(3) = 12.000
	m_tmp(1) = 1.464
	m_tmp(2) = 3.162 
	m_tmp(3) = 1324.96

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	N_sites_tmp(3) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0d0
	kij_tmp(1,3) = 0.0d0
	kij_tmp(2,1) = 0.0d0
	kij_tmp(2,2) = 0.0d0
	kij_tmp(2,3) = -2.2197d-7
	kij_tmp(3,1) = 0.0d0
	kij_tmp(3,2) = -2.2197d-7
	kij_tmp(3,3) = 0.0d0
	u0_tmp(1,1) = 212.06
	u0_tmp(2,2) = 202.49
	u0_tmp(3,3) = 210.00
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(3) = 10.0d0


!	For ethylene (1) and polyethylene(2) to (37)
else if (switch .eq. 9) then
	v00_tmp(1) = 18.157
	m_tmp(1) = 1.464
	N_sites_tmp(1) = 0
	u0_tmp(1,1) = 212.06
	e_ii_tmp(1) = 10.0d0

	forall (i=2:37, j=2:37)
		kij_tmp(i,j) = 0.0d0
	end forall

	do i = 2, 37
		kij_tmp(1,i) = 0.0386
	end do

	do i = 2, 37
		v00_tmp(i) = 12.000
		N_sites_tmp(i) = 0.0d0
		u0_tmp(i,i) = 228.36
		e_ii_tmp(i) = 10.0d0
	end do
		
	





!	For ethylene (1) and polyethylene (2)
else if (switch .eq. 8) then
	v00_tmp(2) = 12
	v00_tmp(1) = 18.157
	m_tmp(2) = 3534.3
	m_tmp(1) = 1.464

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.0386
	kij_tmp(2,1) = 0.0386
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 228.36
	u0_tmp(1,1) = 212.06
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(1) = 10.0d0

else if (switch .eq. 5) then
	v00_tmp(1) = 12.475
	v00_tmp(2) = 12.0
	v00_tmp(3) = 12.0
	m_tmp(1) = 4.724
	m_tmp(2) = 1681.68 
	m_tmp(3) = 7644

	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	N_sites_tmp(3) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = -0.0035
	kij_tmp(1,3) = -0.0035
	kij_tmp(2,1) = -0.0035
	kij_tmp(2,2) = 0.0d0
	kij_tmp(2,3) = 0.0d0
	kij_tmp(3,1) = -0.0035
	kij_tmp(3,2) = 0.0d0
	kij_tmp(3,3) = 0.0d0
	u0_tmp(1,1) = 202.72
	u0_tmp(2,2) = 216.15
	u0_tmp(3,3) = 216.15
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0
	e_ii_tmp(3) = 10.0d0

else if (switch .eq. 6) then
!	Below is octane(1) and polyethylene-octene(2) system
	v00_tmp(1) = 12.234
	v00_tmp(2) = 12.0
	m_tmp(1) = 6.045
	m_tmp(2) = 1681.68

	N_sites_tmp(2) = 1
	N_sites_tmp(1) = 1
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = -0.0035
	kij_tmp(2,1) = -0.0035
	kij_tmp(2,2) = 0.0d0
	u0_tmp(1,1) = 206.03
	u0_tmp(2,2) = 216.15
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

else if (switch .eq. 1) then
!	Below is the hexane(1) and polyethylene-octene(2) system
	v00_tmp(1) = 12.475 
	v00_tmp(2) = 12.0
	m_tmp(1) = 4.724
	m_tmp(2) = 1681.68
!	m_tmp(2) = 7644

	N_sites_tmp(2) = 0
	N_sites_tmp(1) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = -0.0035
	kij_tmp(2,1) = -0.0035
	kij_tmp(2,2) = 0.0d0

	u0_tmp(1,1) = 202.72
	u0_tmp(2,2) = 216.15
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

else if (switch .eq. 2) then

!	Below is the hexane(2) and hexadecane(1) system
	v00_tmp(2) = 11.58
	v00_tmp(1) = 13.5
	m_tmp(2) = 5.31
	m_tmp(1) = 11.82
	N_sites_tmp(2) = 0
	N_sites_tmp(1) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.05
	kij_tmp(2,1) = 0.05
	kij_tmp(2,2) = 0.0d0
	u0_tmp(2,2) = 187.25
	u0_tmp(1,1) = 204.33
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

else if (switch .eq. 3) then


!	Below is the ethylene(1) and heptane(2) system
	v00_tmp(1) = 18.157
	v00_tmp(2) = 12.282
	m_tmp(1) = 1.464
	m_tmp(2) = 5.391
	N_sites_tmp(1) = 0
	N_sites_tmp(2) = 0
	kij_tmp(1,1) = 0.0d0
	kij_tmp(1,2) = 0.06
	kij_tmp(2,1) = 0.06
	kij_tmp(2,2) = 0.0d0
	u0_tmp(1,1) = 212.06
	u0_tmp(2,2) = 204.61
	e_ii_tmp(1) = 10.0d0
	e_ii_tmp(2) = 10.0d0

else if (switch .eq. 4) then

!	Below is methane, CO2, hexadecane system
	v00_tmp(1) = 21.576
	v00_tmp(2) = 13.578
	v00_tmp(3) = 12.3
	m_tmp(1) = 1.0d0
	m_tmp(2) = 1.417 
	m_tmp(3) = 11.209
	N_sites_tmp(1) = 1
	N_sites_tmp(2) = 1
	N_sites_tmp(3) = 1
	kij_tmp(1,1) = 0
	kij_tmp(1,2) = 0
	kij_tmp(1,3) = 0
	kij_tmp(2,1) = 0
	kij_tmp(2,2) = 0
	kij_tmp(2,3) = 0
	kij_tmp(3,1) = 0
	kij_tmp(3,2) = 0
	kij_tmp(3,3) = 0
	u0_tmp(1,1) = 190.29 
	u0_tmp(2,2) = 216.08
	u0_tmp(3,3) = 210.65
	e_ii_tmp(1) = 1.0d0
	e_ii_tmp(2) = 40
	e_ii_tmp(3) = 10

end if

!D(1,1) = -8.8043
!D(1,2) = 4.1646270
!D(1,3) = -48.203555
!D(1,4) = 140.43620
!D(1,5) = -195.23339
!D(1,6) = 113.51500
!D(1,7) = 0.0D0
!D(1,8) = 0.0D0
!D(1,9) = 0.0D0

!D(2,1) = 2.9396
!D(2,2) = -6.0865383
!D(2,3) = 40.137956
!D(2,4) = -76.230797
!D(2,5) = -133.70055
!D(2,6) = 860.25349
!D(2,7) = -1535.3224
!D(2,8) = 1221.4261
!D(2,9) = -409.10539

!D(3,1) = -2.8225
!D(3,2) = 4.7600148
!D(3,3) = 11.257177
!D(3,4) = -66.382743
!D(3,5) = 69.248785
!D(3,6) = 0.d0
!D(3,7) = 0.d0
!D(3,8) = 0.d0
!D(3,9) = 0.d0

!D(4,1) = 0.34
!D(4,2) = -3.1875014
!D(4,3) = 12.231796
!D(4,4) = -12.110681
!D(4,5) = 0.d0
!D(4,6) = 0.d0
!D(4,7) = 0.d0
!D(4,8) = 0.d0
!D(4,9) = 0.d0


end subroutine