subroutine minf_fcn(N2, input, output)

!	The subroutine presents the proper argument list required by the IMSL
!	routine DUMINF.  N2 is the number of variables.  output is the gibbs
!	free energy corresponding to the particular composition x(i)s (input).  

!	Record of revisions:
!			Date		Programmer				Description of Change
!			====		==========				=====================
!			3/31/00		P.D. Ting				inception
!



use essentials
implicit none

!	Declaring variables in the input/output argument list
real (KIND=double), dimension(ncp), intent(in) :: input
real (KIND=double), dimension(ncp) :: input_temp
real (KIND=double), intent(out) :: output
integer, intent(in) :: N2
integer :: statusXX
real (KIND=double) :: sum
real (KIND=double) :: gibbsfcn

integer :: i, j

external gibbsfcn


sum = 0.0d0
statusXX = 1

do i=1, ncp
  if ( (input(i) .lt. 0.0d0) .or. (input(i) .gt. 1.0d0)) then 
	statusXX = 0
  end if

  sum = sum + input(i)
end do

if (sum .gt. 1.0000001) then
	statusXX = 0
end if	

!if (sum .lt.0.99999999) then
!	statusXX = 0
!end if

if (statusXX .eq. 1) then 
  output = gibbsfcn(input)
end if

if (statusXX .eq. 0) then
	output = 10000.0
end if

end subroutine

