      subroutine C1_derivatives(m,z3,C1,C2,C3,C4,C5)

      implicit none

      integer, parameter :: single = SELECTED_REAL_KIND(p=6, r=37)
      integer, parameter :: double = SELECTED_REAL_KIND(p=13)
      real (KIND=double) :: m,C1,C2,C3,C4,C5,z3

	!-------Note C1 as defined here is the inverse of C1 in the first PCSAFT paper

	C1 = 1 + m*(8*z3-2*z3**2.0d0)/(1-z3)**4.0d0 +  
     &	(1-m)*(20*z3-27*z3**2.0d0+12*z3**3.0d0-2*z3**4.0d0)/ 
     &	((1.0d0-z3)*(2.0d0-z3))**2.0d0

	!-------C2 is the derivative of 1/C1 wrt z3----------------------------------

      C2 = - C1**(-2.0d0) * (m*(-4*z3**2.0d0 + 20*z3 +8)/(1-z3)**5.0d0 + 
     &	(1.0d0 - m) * (2*z3**3.0d0+12*z3**2.0d0-48*z3+40)/ 
     &	((1-z3)*(2-z3))**3.0d0)
      
      !-------C3 is the derivative of C2 wrt z3-----------------------------------

      C3=(2*((m*(8 - 4*z3))/(1 - z3)**4 +  
     &        (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 +  
     &        ((1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &         ((1 - z3)**2*(2 - z3)**2) + 
     &        (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &         ((1 - z3)**2*(2 - z3)**3) + 
     &        (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &         ((1 - z3)**3*(2 - z3)**2))**2)/ 
     &   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 +  
     &      ((1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &       ((1 - z3)**2*(2 - z3)**2))**3 -  
     &  ((8*m*(8 - 4*z3))/(1 - z3)**5 - (4*m)/(1 - z3)**4 +  
     &     ((1 - m)*(-54 + 72*z3 - 24*z3**2))/ 
     &      ((1 - z3)**2*(2 - z3)**2) + 
     &     (20*m*(8*z3 - 2*z3**2))/(1 - z3)**6 + 
     &     (4*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &      ((1 - z3)**2*(2 - z3)**3) +  
     &     (4*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &      ((1 - z3)**3*(2 - z3)**2) + 
     &     (6*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**2*(2 - z3)**4) + 
     &     (8*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**3*(2 - z3)**3) + 
     &     (6*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**4*(2 - z3)**2))/ 
     &   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 +  
     &      ((1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &       ((1 - z3)**2*(2 - z3)**2))**2

      !------C4 is the derivative of C3 wrt z3-----------------------------------
	
	C4= (-6*((m*(8 - 4*z3))/(1 - z3)**4 + 
     &        (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 + 
     &        ((1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &         ((1 - z3)**2*(2 - z3)**2) + 
     &        (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &         ((1 - z3)**2*(2 - z3)**3) + 
     &        (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &         ((1 - z3)**3*(2 - z3)**2))**3)/ 
     &   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 +  
     &      ((1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &       ((1 - z3)**2*(2 - z3)**2))**4 + 
     &  (6*((8*m*(8 - 4*z3))/(1 - z3)**5 - (4*m)/(1 - z3)**4 + 
     &       ((1 - m)*(-54 + 72*z3 - 24*z3**2))/ 
     &        ((1 - z3)**2*(2 - z3)**2) + 
     &       (20*m*(8*z3 - 2*z3**2))/(1 - z3)**6 + 
     &       (4*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &        ((1 - z3)**2*(2 - z3)**3) + 
     &       (4*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &        ((1 - z3)**3*(2 - z3)**2) + 
     &       (6*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &        ((1 - z3)**2*(2 - z3)**4) + 
     &       (8*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &        ((1 - z3)**3*(2 - z3)**3) + 
     &       (6*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &        ((1 - z3)**4*(2 - z3)**2))* 
     &     ((m*(8 - 4*z3))/(1 - z3)**4 + 
     &       (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 + 
     &       ((1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &        ((1 - z3)**2*(2 - z3)**2) + 
     &       (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &        ((1 - z3)**2*(2 - z3)**3) + 
     &       (2*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &        ((1 - z3)**3*(2 - z3)**2)))/ 
     &   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     &      ((1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &       ((1 - z3)**2*(2 - z3)**2))**3 - 
     &  ((60*m*(8 - 4*z3))/(1 - z3)**6 - (48*m)/(1 - z3)**5 +  
     &     ((1 - m)*(72 - 48*z3))/((1 - z3)**2*(2 - z3)**2) + 
     &     (6*(1 - m)*(-54 + 72*z3 - 24*z3**2))/ 
     &      ((1 - z3)**2*(2 - z3)**3) + 
     &     (6*(1 - m)*(-54 + 72*z3 - 24*z3**2))/ 
     &      ((1 - z3)**3*(2 - z3)**2) + 
     &     (120*m*(8*z3 - 2*z3**2))/(1 - z3)**7 + 
     &     (18*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &      ((1 - z3)**2*(2 - z3)**4) + 
     &     (24*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &      ((1 - z3)**3*(2 - z3)**3) + 
     &     (18*(1 - m)*(20 - 54*z3 + 36*z3**2 - 8*z3**3))/ 
     &      ((1 - z3)**4*(2 - z3)**2) + 
     &     (24*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**2*(2 - z3)**5) + 
     &     (36*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**3*(2 - z3)**4) + 
     &     (36*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**4*(2 - z3)**3) + 
     &     (24*(1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &      ((1 - z3)**5*(2 - z3)**2))/ 
     &   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     &      ((1 - m)*(20*z3 - 27*z3**2 + 12*z3**3 - 2*z3**4))/ 
     &       ((1 - z3)**2*(2 - z3)**2))**2

      !-----C5 is the derivative of C4 wrt z3------------------------

	C5 = (24*((m*(8 - 4*z3))/(1 - z3)**4 + 
     -        (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 + 
     -        ((1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -         ((1 - z3)**2*(2 - z3)**2) + 
     -        (2*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**2*(2 - z3)**3) + 
     -        (2*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**3*(2 - z3)**2))**4)/
     -   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     -      ((1 - m)*(20*z3 + 27*z3**2 + 12*z3**3 - 
     -           2*z3**4))/((1 - z3)**2*(2 - z3)**2))**5 - 
     -  (36*((8*m*(8 - 4*z3))/(1 - z3)**5 - 
     -       (4*m)/(1 - z3)**4 + 
     -       ((1 - m)*(54 + 72*z3 - 24*z3**2))/
     -        ((1 - z3)**2*(2 - z3)**2) + 
     -       (20*m*(8*z3 - 2*z3**2))/(1 - z3)**6 + 
     -       (4*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**2*(2 - z3)**3) + 
     -       (4*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**3*(2 - z3)**2) + 
     -       (6*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**2*(2 - z3)**4) + 
     -       (8*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**3*(2 - z3)**3) + 
     -       (6*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**4*(2 - z3)**2))*
     -     ((m*(8 - 4*z3))/(1 - z3)**4 + 
     -        (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 + 
     -        ((1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -         ((1 - z3)**2*(2 - z3)**2) + 
     -        (2*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**2*(2 - z3)**3) + 
     -        (2*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**3*(2 - z3)**2))**2)/
     -   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     -      ((1 - m)*(20*z3 + 27*z3**2 + 12*z3**3 - 
     -           2*z3**4))/((1 - z3)**2*(2 - z3)**2))**4 + 
     -  (6*((8*m*(8 - 4*z3))/(1 - z3)**5 - 
     -        (4*m)/(1 - z3)**4 + 
     -        ((1 - m)*(54 + 72*z3 - 24*z3**2))/
     -         ((1 - z3)**2*(2 - z3)**2) + 
     -        (20*m*(8*z3 - 2*z3**2))/(1 - z3)**6 + 
     -        (4*(1 - m)*
     -           (20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -         ((1 - z3)**2*(2 - z3)**3) + 
     -        (4*(1 - m)*
     -           (20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -         ((1 - z3)**3*(2 - z3)**2) + 
     -        (6*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**2*(2 - z3)**4) + 
     -        (8*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**3*(2 - z3)**3) + 
     -        (6*(1 - m)*
     -           (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -         ((1 - z3)**4*(2 - z3)**2))**2)/
     -   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     -      ((1 - m)*(20*z3 + 27*z3**2 + 12*z3**3 - 
     -           2*z3**4))/((1 - z3)**2*(2 - z3)**2))**3 + 
     -  (8*((60*m*(8 - 4*z3))/(1 - z3)**6 - 
     -       (48*m)/(1 - z3)**5 + 
     -       ((1 - m)*(72 - 48*z3))/
     -        ((1 - z3)**2*(2 - z3)**2) + 
     -       (6*(1 - m)*(54 + 72*z3 - 24*z3**2))/
     -        ((1 - z3)**2*(2 - z3)**3) + 
     -       (6*(1 - m)*(54 + 72*z3 - 24*z3**2))/
     -        ((1 - z3)**3*(2 - z3)**2) + 
     -       (120*m*(8*z3 - 2*z3**2))/(1 - z3)**7 + 
     -       (18*(1 - m)*
     -          (20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**2*(2 - z3)**4) + 
     -       (24*(1 - m)*
     -          (20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**3*(2 - z3)**3) + 
     -       (18*(1 - m)*
     -          (20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**4*(2 - z3)**2) + 
     -       (24*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**2*(2 - z3)**5) + 
     -       (36*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**3*(2 - z3)**4) + 
     -       (36*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**4*(2 - z3)**3) + 
     -       (24*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**5*(2 - z3)**2))*
     -     ((m*(8 - 4*z3))/(1 - z3)**4 + 
     -       (4*m*(8*z3 - 2*z3**2))/(1 - z3)**5 + 
     -       ((1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -        ((1 - z3)**2*(2 - z3)**2) + 
     -       (2*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**2*(2 - z3)**3) + 
     -       (2*(1 - m)*
     -          (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -        ((1 - z3)**3*(2 - z3)**2)))/
     -   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     -      ((1 - m)*(20*z3 + 27*z3**2 + 12*z3**3 - 
     -           2*z3**4))/((1 - z3)**2*(2 - z3)**2))**3 - 
     -  ((480*m*(8 - 4*z3))/(1 - z3)**7 - 
     -     (480*m)/(1 - z3)**6 + 
     -     (8*(1 - m)*(72 - 48*z3))/
     -      ((1 - z3)**2*(2 - z3)**3) + 
     -     (8*(1 - m)*(72 - 48*z3))/
     -      ((1 - z3)**3*(2 - z3)**2) - 
     -     (48*(1 - m))/((1 - z3)**2*(2 - z3)**2) + 
     -     (36*(1 - m)*(54 + 72*z3 - 24*z3**2))/
     -      ((1 - z3)**2*(2 - z3)**4) + 
     -     (48*(1 - m)*(54 + 72*z3 - 24*z3**2))/
     -      ((1 - z3)**3*(2 - z3)**3) + 
     -     (36*(1 - m)*(54 + 72*z3 - 24*z3**2))/
     -      ((1 - z3)**4*(2 - z3)**2) + 
     -     (840*m*(8*z3 - 2*z3**2))/(1 - z3)**8 + 
     -     (96*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -      ((1 - z3)**2*(2 - z3)**5) + 
     -     (144*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -      ((1 - z3)**3*(2 - z3)**4) + 
     -     (144*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -      ((1 - z3)**4*(2 - z3)**3) + 
     -     (96*(1 - m)*(20 + 54*z3 + 36*z3**2 - 8*z3**3))/
     -      ((1 - z3)**5*(2 - z3)**2) + 
     -     (120*(1 - m)*
     -        (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -      ((1 - z3)**2*(2 - z3)**6) + 
     -     (192*(1 - m)*
     -        (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -      ((1 - z3)**3*(2 - z3)**5) + 
     -     (216*(1 - m)*
     -        (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -      ((1 - z3)**4*(2 - z3)**4) + 
     -     (192*(1 - m)*
     -        (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -      ((1 - z3)**5*(2 - z3)**3) + 
     -     (120*(1 - m)*
     -        (20*z3 + 27*z3**2 + 12*z3**3 - 2*z3**4))/
     -      ((1 - z3)**6*(2 - z3)**2))/
     -   (1 + (m*(8*z3 - 2*z3**2))/(1 - z3)**4 + 
     -      ((1 - m)*(20*z3 + 27*z3**2 + 12*z3**3 - 
     -           2*z3**4))/((1 - z3)**2*(2 - z3)**2))**2
    
      end subroutine 	 

