	subroutine assoc(m,u0,TK,rhox,a_assoc,z_assoc)
	Implicit double precision(a-h,o-z)
	double precision m,kappa
	
	common/par/sigc
	common/assoc/kappa, e_k_assoc

	!For 2B association model (valid for alcohols)
	
	rg = 82.0535d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
	
	factor=1.0d0-0.12*exp(-3*u0/TK)   ! Ratio of d to sigma
      D=(sig*factor)**3.d0 
	rho = rhox/D

	eta = (pi/6.0d0)*rhox*m
	g_hs = (1-0.5*eta)/(1-eta**3)
	delta = g_hs*(exp(e_k_assoc / TK) - 1)*sigc**3*kappa
	!xa = (1+Nav*(summa B) rho*xb*delta_AB)**(-1.0d0)
	xa = (-1 + (1 + 4*rho*delta)**0.50d0)/(2*rho*delta)
	
	dghs_deta = -0.50d0/(1-eta)**3 + 3.0d0*(1-0.5*eta)/(1-eta)**4

	dghs_drho = (pi/6.0d0)*m*D*dghs_deta

	drhodelta_drho = 
     & rho*(exp(e_k_assoc / TK) - 1)*sigc**3*kappa*dghs_drho + delta

	dxa_drho = 
     & (2*rho*delta*(0.50d0*(1+4*rho*delta)**0.5*4*drhodelta_drho) -
     & (-1+(1+4*rho*delta)**0.5)*2*drhodelta_drho) / (2*rho*delta)**2

	
	z_assoc = rho*2*(1/xa - 0.50d0)*dxa_drho

	a_assoc = 2*(dlog(xa) - xa/2.0d0) + 1.0d0


	


	end subroutine