c--------------------------------------------------------------------------
      subroutine dispersion(m,eta,deta_dT,d2eta_dT2,d2eta_drho_dT,
     &		d3eta_drho_dT2,deta_drho,u0,e_ii,TK_local,amf,damf_deta,
     &       d2amf_deta2,d3amf_deta3,damf_dT,d2amf_dT2,d2amf_drho_dT,
     &       d3amf_drho_dT2)
	implicit double precision (a-h,o-z)
	double precision m
	dimension d(4,9)
	common/Pmf_der_u/dPdu02
c
	rg = 83.14506585d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
c
	n_i = 4
      n_j = 9
c
c  D(i,j) parameters from Chen and Kreglewski
c
      D(1,1) = -8.8043
      D(1,2) = 4.1646270
      D(1,3) = -48.203555
      D(1,4) = 140.43620
      D(1,5) = -195.23339
      D(1,6) = 113.51500
      D(1,7) = 0.0D0
      D(1,8) = 0.0D0
      D(1,9) = 0.0D0

      D(2,1) = 2.9396
      D(2,2) = -6.0865383
      D(2,3) = 40.137956
      D(2,4) = -76.230797
      D(2,5) = -133.70055
      D(2,6) = 860.25349
      D(2,7) = -1535.3224
      D(2,8) = 1221.4261
      D(2,9) = -409.10539

      D(3,1) = -2.8225
      D(3,2) = 4.7600148
      D(3,3) = 11.257177
      D(3,4) = -66.382743
      D(3,5) = 69.248785
      D(3,6) = 0.d0
      D(3,7) = 0.d0
      D(3,8) = 0.d0
      D(3,9) = 0.d0

      D(4,1) = 0.34
      D(4,2) = -3.1875014
      D(4,3) = 12.231796
      D(4,4) = -12.110681
      D(4,5) = 0.d0
      D(4,6) = 0.d0
      D(4,7) = 0.d0
      D(4,8) = 0.d0
      D(4,9) = 0.d0

c
	tau = (pi / 6.D0) * sqrt(2.D0)
      C1 = 0.12D0
	u = u0 * (1.D0 + e_ii / TK_local) 
	U_kT=u/TK_local

	dU_kT_dT=-u/TK_local**2-2.0d0*u0*e_ii/TK_local**3

	d2U_kT_dT2 = 2.0d0 * u/TK_local**3.0d0 + 4.0d0*u0*e_ii/
     &	TK_local**4.0d0

	amf = 0.0D0
      damf_deta = 0.0D0
	d2amf_deta2 = 0.0d0
	d3amf_deta3 = 0.0d0
	damf_dT=0.0d0
	d2amf_dT2 = 0.0d0
	d2amf_drho_dT = 0.0d0
	d3amf_drho_dT2 = 0.0d0
	
      do i = 1, n_i
	do j = 1, n_j
c	  
	  amf = amf + m * D(i,j) * ( U_kT **DBLE(i)) * 
     &	  ( eta/ tau )**DBLE(j)

	  damf_deta = damf_deta + m * dble(j)*D(i,j)*(u/TK_local)**dble(i)
     &	  *(eta/tau)**dble(j-1)/tau	 

	  d2amf_deta2 = d2amf_deta2 +m*j*(j-1)*D(i,j)*(u/TK_local)**i*
     &	  (eta/tau)**(j-2)/tau**2

	  d3amf_deta3 = d3amf_deta3 + m * j*(j-1)*(j-2)*D(i,j)*
     &      (u/TK_local)**i*(eta/tau)**(j-3)/tau**3

	   damf_dT = damf_dT +m*(D(i,j)*(i*(u/TK_local)**(i-1)*dU_kT_dT*
     &	   (eta/tau)**j+(u/TK_local)**i*j*(eta/tau)**(j-1)/
     &       tau*deta_dT))

	   d2amf_dT2 = d2amf_dT2 +m*(D(i,j)*(i*((i-1)*(u/TK_local)**(i-2)*
     &   dU_kT_dT**2*(eta/tau)**j+(u/TK_local)**(i-1)*d2U_kT_dT2*(eta
     &   /tau)**j)+2.0D0*i*j/tau*(u/TK_local)**(i-1)*dU_kT_dT*(eta/tau)
     &   **(j-1)*deta_dT+j/tau*((u/TK_local)**i*(j-1)*(eta/tau)**(j-2)/
     &   tau*deta_dT**2+(u/TK_local)**i*(eta/tau)**(j-1)*d2eta_dT2)))

	   d2amf_drho_dT = d2amf_drho_dT + m*(D(i,j)*(i*(u/TK_local)**
     &   (i-1)*dU_kT_dT*j*(eta/tau)**(j-1)/tau*deta_drho+(u/TK_local)**i
     &   *j/tau*((j-1)*(eta/tau)**(j-2)/tau*deta_drho*deta_dT+
     &   (eta/tau)**(j-1)*d2eta_drho_dT)))

	   d3amf_drho_dT2 = d3amf_drho_dT2 +m*(D(i,j)*(i*((i-1)*j/tau*(u/
     &   TK_local)**(i-2)*dU_kT_dT**2*(eta/tau)**(j-1)*deta_drho+
     &  (u/TK_local)**(i-1)*d2U_kT_dT2*j/tau*(eta/tau)**(j-1)*deta_drho)
     &   +2.0D0*i*j/tau*(u/TK_local)**(i-1)*dU_kT_dT*((j-1)/tau*(eta/
     &  tau)**(j-2)*deta_drho*deta_dT+(eta/tau)**(j-1)*d2eta_drho_dT)+
     &  j/tau*((j-1)/tau*(u/TK_local)**i*((j-2)/tau*(eta/tau)**(j-3)*
     &  deta_drho*deta_dT**2+2.0D0*(eta/tau)**(j-2)*deta_dT*
     &  d2eta_drho_dT)+(u/TK_local)**i*((j-1)/tau*(eta/tau)**(j-2)*
     &  deta_drho*d2eta_dT2+(eta/tau)**(j-1)*d3eta_drho_dT2))))
		  


	 end do
      end do

	zmf = eta * damf_deta

	dzmf_deta =  damf_deta + eta * d2amf_deta2

	d2zmf_deta2 = 2.0d0 * d2amf_deta2 + eta * d3amf_deta3


	
c	
	return
	end


