c ----------------Auleen coded pc_dispersion 20 june 2001 --------------------
	subroutine pc_dispersion(m,z3,dz3_dT,d2z3_dT2,d2z3_drho_dT,
     &	d3z3_drho_dT2,dz3_drho,u0,sigc,TK_local,amf,damfdz,
     &       damfdz2,damfdz3,damfdT,damfdT2,d2amf_drho_dT,
     &       d3amf_drho_dT2)
	
	implicit double precision (a-h,o-z)
      double precision  m,  u0, v00
      DOUBLE PRECISION I1,I2, edI1dz, edI2dz, z00, z00_dz, z00_d2,
     &                 drdpkt, drdpdz, myres
      DOUBLE PRECISION ap(7,3),bp(7,3),zms,order1,order2,apar(7),bpar(7)
      DATA PI, avog/3.141592654D0, 0.602252d0/
c
      call pcsaft_universal(m,apar,bpar)

	call C1_derivatives(m,z3,C1,C2,C3,C4,C5)

	!in this subroutine, the derivatives of zmf and amf are taken wrt packing fraction
	!and not density, if wish derivatives wrt densitym multiply by deta/drho

      zms = 1.d0-z3
c-----Expressions for I1, I2, edI1dz = d(z3*I1)/d(z3) and edI2dz = d(z3*I2)/d(z3)-----
c-----Note that the sigc^3 that should be in order1 and order2 is accounted for in rhox
      
	order1=(m**2.0)*u0/TK_local
	order2=order1*u0/TK_local

c
c
        I1    = 0.d0
        I2    = 0.d0
        edI1dz = 0.d0
        edI2dz = 0.d0
	  edI1dz2=0.0d0
	  edI2dz2=0.0d0
	  edI1dz3=0.0d0
	  edI2dz3=0.0d0
	  edI1dz4 = 0.0d0
	  edI2dz4 = 0.0d0
	  dI1dT=0.0d0
	  dI2dT=0.0d0
        do j=0,6

          I1  = I1 + apar(j+1)*z3**DBLE(j)
          I2  = I2 + bpar(j+1)*z3**DBLE(j)

	    !---------first derivatives wrt z3------------------------------------
          edI1dz = edI1dz + apar(j+1)*DBLE(j+1)*z3**DBLE(j)
          edI2dz = edI2dz + bpar(j+1)*DBLE(j+1)*z3**DBLE(j)

	    !---------second derivatives wrt z3-----------------------------------
	    edI1dz2=edI1dz2 + apar(j+1)*dble(j+1)*dble(j)*z3**dble(j-1)
	    edI2dz2=edI2dz2 + bpar(j+1)*dble(j+1)*dble(j)*z3**dble(j-1)

	    !---------third derivatives wrt z3------------------------------------
	    edI1dz3=edI1dz3+apar(j+1)*dble(j+1)*dble(j)*dble(j-1) 
     &    *z3**dble(j-2)

	    edI2dz3=edI2dz3+bpar(j+1)*dble(j+1)*dble(j)*dble(j-1) 
     &    *z3**dble(j-2)

	    !--------fourth derivatives wrt z3------------------------------------
	    edI1dz4 = edI1dz4 + apar(j+1) * dble(j+1)*dble(j)*dble(j-1)
     &    * dble(j-2) * z3**dble(j-3)

	    edI2dz4 = edI2dz4 + bpar(j+1) * dble(j+1)*dble(j)*dble(j-1)
     &    * dble(j-2) * z3**dble(j-3)

	    !-------first derivatives wrt T---------------------------------------
	    dI1dT=dI1dT+apar(j+1)*dble(j)*dz3_dT*z3**dble(j-1)
	    dI2dT=dI2dT+bpar(j+1)*dble(j)*dz3_dT*z3**dble(j-1)

	    !-------second derivatives wrt T--------------------------------------


        end do

c-----Expressions for edI1dz2=d2(z3*I1)/d(z3)2 and edI2dz2 = d2(z3*I2)/d(z3)2---

      
	dI1dT2=0.0d0
	dI2dT2=0.0d0

	edI1dzdT=0.0d0    !d(d(z3I1)dz3)/dT
	edI2dzdT=0.0d0    !d(d(z3I2)dz3)/dT

	edI1dzdT2 = 0.0d0 !d2(d(z3I1)dz3)/dT2
	edI2dzdT2 = 0.0d0 !d2(d(z3I2)dz3)/dT2

	do j=1,6	  

	  dI1dT2 = dI1dT2 + apar(j+1)*dble(j)*(d2z3_dT2*z3**dble(j-1)
     &  +dble(j-1)*dz3_dT**2.0d0*z3**dble(j-2))

	  dI2dT2 = dI2dT2 + bpar(j+1)*dble(j)*(d2z3_dT2*z3**dble(j-1)
     &  +dble(j-1)*dz3_dT**2.0d0*z3**dble(j-2))

	  edI1dzdT = edI1dzdT + apar(j+1) * dble(j) * dble(j+1) * dz3_dT
     &    *z3**dble(j-1)

        edI2dzdT = edI2dzdT + bpar(j+1) * dble(j) * dble(j+1) * dz3_dT
     &    *z3**dble(j-1)

	  edI1dzdT2 = edI1dzdT2 + apar(j+1) * dble(j+1) * dble(j) * 
     &	  (dble(j-1) * dz3_dT**2.0d0 * z3**dble(j-2) + d2z3_dT2 * 
     &      z3**dble(j-1))

	  edI2dzdT2 = edI2dzdT2 + bpar(j+1) * dble(j+1) * dble(j) * 
     &	  (dble(j-1) * dz3_dT**2.0d0 * z3**dble(j-2) + d2z3_dT2 * 
     &      z3**dble(j-1))

	end do

!-----Expressions for edI1dz3=d3(z3*I1)/d(z3)3 and edI2dz3 = d3(z3*I2)/d(z3)3---
	
      
	dI1dzdT2 = 0.0d0
	dI2dzdT2 = 0.0d0


	do j=2,6	  

	  dI1dzdT2 = dI1dzdT2 + apar(j+1) * dble(j+1) * dble(j) *
     & (d2z3_dT2 * z3**dble(j-1) + dz3_dT**2.0d0 * dble(j-1) * 
     &  z3**dble(j-2))

	  dI2dzdT2 = dI2dzdT2 + bpar(j+1) * dble(j+1) * dble(j) *
     & (d2z3_dT2 * z3**dble(j-1) + dz3_dT**2.0d0 * dble(j-1) * 
     &  z3**dble(j-2))
	end do

!--------------------------------------------------------------------------------
c------------Note C1 as defined here is the inverse of C1 in the first PCSAFT paper
      
	dC1dT = dz3_dT * C2
      
	d2C1dT2 = d2z3_dT2 * C2 + dz3_dT**2.0d0 * C3

	dC2dT = dz3_dT * C3

	d2C2dT2 = d2z3_dT2 * C3 + dz3_dT**2.0d0 * C4
	
	dC1dTdz = dz3_dT * C3 + dz3_dT * C2 / z3
	 
      rho_local=z3/(pi/6.0d0*m*(1.0d0-0.12*dexp(-3*u0/TK_local))**3.0d0)
  
	!-------derivatives of term1 wrt z3----------------------------------------
	
	term1 = edI2dz/C1 + C2 * z3 * I2

	dterm1_dz = edI2dz2/C1 + 2.0d0 * C2 * edI2dz + C3 * z3 * I2

	dterm1_dz2 = edI2dz3/C1 + 3.0d0 * C2 * edI2dz2 + 
     &  3.0d0 * C3 * edI2dz + C4 * z3 * I2

	dterm1_dz3 = edI2dz4/C1 + 4.0d0 * C2 * edI2dz3 +
     &	 6.0d0 * C3 * edI2dz2 + 4.0d0 * C4 * edI2dz + C5 * z3 * I2

	!------mixed derivatives of term1------------------------------------------

	dterm1_dT = dC1dT * edI2dz + edI2dzdT/C1 + dC2dT*z3*I2 + C2 * 
     &   dz3_dT * edI2dz

	dterm1_dT2 = d2C1dT2 * edI2dz + 2.0d0 * dC1dT * edI2dzdT + 
     &   edI2dzdT2/C1 + d2C2dT2 * z3 * I2 + 2.0d0 * dC2dT * dz3_dT
     &   * edI2dz + C2 * (d2z3_dT2 * edI2dz + dz3_dT * edI2dzdT)	 

	!-------derivatives of term2 wrt T-----------------------------------------

	term2 = dC1dT * I2 + dI2dT/C1 - 2.0d0 * I2/C1/TK_local

	dterm2_dT = d2C1dT2 * I2 + 2.0d0 * dC1dT * dI2dT + dI2dT2/C1 - 
     &   2.0d0 * dC1dT * I2/TK_local - 2.0d0 * dI2dT/C1/TK_local + 
     &   2.0d0 * I2/C1/TK_local**2.0d0


c------------free energy and its derivatives wrt packing fraction-------------------------

	amf=(-2.0d0*pi*rho_local*I1*order1 - 
     &	pi*m*rho_local*C1**(-1.0d0)*I2*order2)

	damfdz = -2.0d0 * pi * (rho_local/z3) * order1 * edI1dz - 
     &      pi * (rho_local/z3) * m * order2 * term1

	damfdz2 = -2.0d0 * pi * (rho_local/z3) * edI1dz2 * order1
     &  - pi * (rho_local/z3) * m * order2 * dterm1_dz

	damfdz3 = -2.0d0 * pi * (rho_local/z3) * edI1dz3 * order1 - 
     &   pi * rho_local/z3 * m * dterm1_dz2 * order2

   
c-----------derivatives of free energy wrt T----------------------------------------------

      damfdT=-2.0d0*pi*rho_local*(dI1dT-I1/TK_local)*order1-
     & pi*rho_local*m*term2 * order2

	damfdT2 = -2.0d0 * pi * rho_local * (dI1dT2 - dI1dT/TK_local + 
     &   I1/TK_local**2.0d0) * order1 + 2.0d0 * pi * rho_local * (dI1dT-
     &   I1/TK_local) * order1/TK_local - pi * m * rho_local * dterm2_dT 
     &   * order2 + 2.0d0 * pi * rho_local * m * term2 * order2/TK_local

c----------mixed derivatives of free energy----------------------------------------------

      d2amf_drho_dT = -2.0d0 * pi * (edI1dzdT - edI1dz/TK_local)*order1
     &   -pi * m * order2 * (dterm1_dT - 2.0d0*term1/TK_local)
           
	d3amf_drho_dT2 = -2.0d0 * pi * order1 * (edI1dzdT2 - edI1dzdT/
     &	TK_local + edI1dz/TK_local**2.0d0) + 2.0d0 * pi * order1/
     &    TK_local * (edI1dzdT - edI1dz/TK_local) - pi * m * order2 *
     &    (dterm1_dT2 - 2.0d0 * dterm1_dT/TK_local + 2.0d0 * term1 /
     &    TK_local**2.0d0) + 2.0d0 * pi * m * order2 / TK_local * (
     &    dterm1_dT - 2.0d0 * term1 / TK_local)        




	return
	end subroutine
c
