	subroutine polar_int(rost,xp,tstar,F,zpolar,upolar,dpdrho)
	Implicit none
	double precision pi,rost,tstar,F,I_2,I_3,xp,FN,dPsdxp,pstar
	double precision FD,term2,dI_2drho,dI_3drho
	double precision dFNdrho,dFDdrho,dFNdT,dFDdT,zpolar,upolar
	double precision dFdrho,d2I2_drho2,d2I3_drho2,d2FNdrho2
	double precision d2FDdrho2,d2Fdrho2,dpdrho,dterm2drho 
	common/Pxpder/dPsdxp
	data pi/3.1415926/

	I_2=(1.0d0-0.3618*rost-0.3205*(rost**2)+0.1078*(rost**3))/
     1     ((1.0d0-0.5236*rost)**2)

	I_3=(1+0.62378*rost-0.11658*(rost**2))/(1-0.59056*rost+0.20059*
     1     (rost**2))
	F=(-2*pi/9.0d0)*((1.0d0/tstar)**2)*rost*xp*xp*I_2/(1+
     1   (5*pi/36.0d0)*(1.0d0/tstar)*rost*xp*I_3/I_2)

c
c	Now calculate density and temperature derivatives of F
c	Numerator of F 
c
	FN=-(2.0d0*pi/9.0d0)*((1.0d0/tstar)**2)*rost*(xp**2)*(I_2**2)
c
c	Denominator of F
c
	term2=(5.0d0*pi/36.0d0)*(1.0d0/tstar)*rost*xp*I_3
	FD=I_2+term2
c
	dI_2drho=(1.0d0/(1.0d0-0.5236*rost)**2)*((-0.3618-0.641*rost+
	1	0.3234*(rost**2))+I_2*1.0472*(1.0d0-0.5236*rost))
      dI_3drho=(1.0d0/(1-0.59056*rost+0.20059*(rost**2)))*
	1	(0.62378-0.23316*rost-I_3*(-0.59056+0.40118*rost))
c
	dFNdrho=2.0d0*(FN/I_2)*dI_2drho+FN/rost
	dterm2drho=(term2/I_3)*dI_3drho+term2/rost
      dFDdrho=dI_2drho+dterm2drho
	dFdrho=(dFNdrho-F*dFDdrho)/FD
	zpolar=rost*dFdrho
c
c	Compute second derivatives required for calculating dP/drho
c
	d2I2_drho2=(1.0d0/(1.0d0-0.5236*rost)**2)*(-0.641+0.6468*rost+
	1  2.0944*dI_2drho*(1.0-0.5236*rost)-(1.0472*0.5236)*I_2)
c
      d2I3_drho2=(1.0d0/(1-0.59056*rost+0.20059*(rost**2)))*(-0.23316
	1  -2.0*dI_3drho*(-0.59056+0.40118*rost)-I_3*0.40118)
c
   	d2FNdrho2=(1.0/rost)*dFNdrho-FN/(rost**2)+FN*((2.0/I_2)*d2I2_drho2
	1-dI_2drho*(2.0/(I_2**2))*dI_2drho)+(2.0/I_2)*dI_2drho*dFNdrho
c
	d2FDdrho2=d2I2_drho2-term2/(rost**2)+(1.0/rost)*dterm2drho+
	1(term2/I_3)*d2I3_drho2-(term2/(I_3**2))*(dI_3drho**2)+
	2(1.0/I_3)*dI_3drho*dterm2drho
c
	d2Fdrho2=(1.0/FD)*d2FNdrho2-(1.0/FD**2)*dFNdrho*dFDdrho-
	1(F*d2FDdrho2+dFdrho*dFDdrho)/FD+(F/(FD**2))*(dFDdrho**2)
	dpdrho=(rost**2)*d2Fdrho2+2.0*rost*dFdrho
c
	pstar=zpolar*rost
	dPsdxp=2*pstar/xp+(5.0d0/(8.0d0*(xp**2)))*(2*F*pstar*tstar*I_3/
	1	(I_2**2))+(5.0d0/(8.0d0*(xp**2)))*(F**2)*(rost**2)*(tstar/
	2	(I_2**2))*(dI_3drho-(2.0d0*I_3/I_2)*dI_2drho)
c
c
c	Now compute the temperature derivatives
c
	dFNdT=-2.0d0*FN/tstar
	dFDdT=-term2/tstar
	upolar=-tstar*(1.0d0/FD)*(dFNdT-F*dFDdT)

c
	return
	end
