	subroutine thermo_props(m,rhox,xp,dmu,u0,v00,kappa,epsilon,lambda
     &	,e_ii,TK,zres,ares,dpdrho)
	Implicit double precision(a-h,o-z)
	double precision m,kappa,lambda
	common/polarc/Apolar, Zpolar
	common/disp/idisp_flag
	common/par_polar/ i_polar
	common/assoc/iassoc_flag, num_assoc_site
 
	rg = 82.0535d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143

c---------------------------------------------------------------------------
c     rhox does not contain the T-dependent part of the diameter, only sigc
c---------------------------------------------------------------------------
      sigc=(v00*6.0d0*0.74048d0/pi/AVOG)**(1.0D0/3.0D0)

c---------------------------------------------------------------------------
c-----------compute the packing fraction eta--------------------------------
      eta = rhox*m*pi/6.0d0*(1.0d0-0.12*exp(-3*u0/TK))**3.0d0 

	!----hard sphere contribution-----------------------------------------
	call hsprops(m,eta,ahs,dahs_deta,d2ahs_deta2,d3ahs_deta3) 
	
	!----polar contribution, needs to be updated for use------------------
	if (i_polar.eq.1) then	
		call polarmix(rhox,Apolar,Zpolar,dPpolardrho)
	else if (i_polar.eq.2) then	
		call multipolarmix(rhox,Apolar,Zpolar,dPpolardrho)
	else
		Zpolar=0.0d0
		Apolar=0.0d0
	endif

      !----chain contribution-----------------------------------------------
	call chain(m,eta,achain,dachain_deta,d2achain_deta2,
     &	d3achain_deta3)
      
	!----mean-field contribution------------------------------------------
	if (idisp_flag.eq.0) then
		call dispersion(m,eta,deta_dT,d2eta_dT2,d2eta_drho_dT,
     &		d3eta_drho_dT2,deta_drho,u0,e_ii,TK,amf,damf_deta,
     &       d2amf_deta2,d3amf_deta3,damf_dT,d2amf_dT2,d2amf_drho_dT,
     &       d3amf_drho_dT2)
	
	else
		call pc_dispersion(m,eta,deta_dT,d2eta_dT2,d2eta_drho_dT,
     &		d3eta_drho_dT2,deta_drho,u0,sigc,TK,amf,damf_deta,
     &       d2amf_deta2,d3amf_deta3,damf_dT,d2amf_dT2,d2amf_drho_dT,
     &       d3amf_drho_dT2)
	end if

	!----association contribution----------------------------------------
	if(iassoc_flag.eq.1)then
	call association(TK,rhox,eta,m,sigc,kappa,epsilon,lambda,a_assoc,
     &	z_assoc,num_assoc_site)

	end if
	
	!-----residual helmholtz free energy----------------------------
	ares=m*(ahs+Apolar)+achain+amf+a_assoc

	!----compressibility factor------------------------------------
	zres = eta * (m*dahs_deta+dachain_deta+damf_deta) + z_assoc

c----------------------------------------------------------------------
c---------derivatives of a wrt rho and T, for potential future use----

	!-----first derivative of ares wrt rho--------------------------
	dares_drho = (m*dahs_deta+dachain_deta+damf_deta)*deta_drho

	!-----second derivative of ares wrt rho-------------------------
	d2ares_drho2 = (m*d2ahs_deta2+d2achain_deta2 + d2amf_deta2) 
     &	* deta_drho**2.0d0

	!----third derivative of ares wrt rho---------------------------
	d3ares_drho = (m*d3ahs_deta3 + d3achain_deta3 + d3amf_deta3) *
     &  deta_drho**3.0d0

	!----first derivative of ares wrt T----------------------------- 
	dares_dT=(m*dahs_deta + dachain_deta)*deta_dT + damf_dT

	!----second derivative of ares wrt T----------------------------
	d2ares_dT2 = (m*d2ahs_deta2+d2achain_deta2)*deta_dT**2.0d0 + 
     &  (m*dahs_deta + dachain_deta) * d2eta_dT2 + d2amf_dT2

	!----second mixed derivative of ares----------------------------
	d2ares_drho_dT = (m*d2ahs_deta2+d2achain_deta2) * deta_drho * 
     & deta_dT + (m*dahs_deta + dachain_deta) * d2eta_drho_dT +
     & d2amf_drho_dT

	!----third mixed derivative of ares----------------------------
	d3ares_drho_dT2 = (m*d3ahs_deta3+d3achain_deta3) * deta_drho * 
     &  deta_dT**2.0d0 + (m*d2ahs_deta2 + d2achain_deta2)*(2.0d0 * 
     &  deta_dT * d2eta_drho_dT + deta_drho * d2eta_dT2)+(m*dahs_deta
     &  + dachain_deta)*d3eta_drho_dT2 + d3amf_drho_dT2
	


	return
	end
