subroutine final_properties(x_known, x_guess, rhox1, rhox2, chpt1, chpt2, Pcalc1, Pcalc2,Hrsm)




use essentials

!	Declaring passing variables

!	Declaring local variables
real (KIND=double) :: rhox1, rhox2
real (KIND=double), dimension(ncp) :: x_known, x_guess
real (KIND=double) :: temp, sum, sum2
integer :: temp2, i, j, a, b

!	Declaring SAFT parameters
real (KIND=double), dimension(ncp) :: m, e_ii, v00
integer, dimension(ncp) :: N_sites
real (KIND=double), dimension(ncp, ncp) :: sig, u0, kij
real (KIND=double), dimension(ncp, ncp, max, max,2) :: fa	
real (KIND=double), dimension(ncp, ncp, max, max) :: kappa	
real (KIND=double), dimension(ncp, ncp, max, max, 1) :: fb	
real (KIND=double) :: Prsm, Ursm, Arsm, Grsm, Srsm, Hrsm, Pcalc1, Pcalc2, Gtotal 
real (KIND=double), dimension(ncp) :: chpt1, chpt2, fugacity1, fugacity2, chpt_res1, chpt_res2 


real (KIND=double) :: KA_result1, KA_result2, KB_result1, KB_result2, KA_new, KB_new


!	Here's the meat
!****************************************************************
!	Converting SAFT parameters to appropriate lengths
do i = 1, ncp
  temp = m_tmp(i)
  m(i) = temp
  temp = e_ii_tmp(i)
  e_ii(i) = temp
  temp = v00_tmp(i)
  v00(i) = temp
  temp2 = N_sites_tmp(i)
  N_sites(i) = temp2

  do j = 1, ncp
	temp = sig_tmp(i,j)
	sig(i,j) = temp
	temp = u0_tmp(i,j)
	u0(i,j) = temp
	temp = kij_tmp(i,j)
	kij(i,j) = temp
  end do
end do

do i = 1, ncp
  do a = 1, N_sites(i)
 	do j = 1, ncp
  	  do b = 1, N_sites(j)
		temp = fa_tmp(i,j,a,b,2)	
		fa(i,j,a,b,2) = temp
		temp = fa_tmp(i,j,a,b,1)
		fa(i,j,a,b,1) = temp
		temp = kappa_tmp(i,j,a,b)
		kappa(i,j,a,b) = temp
		temp = fb_tmp(i,j,a,b,1)
		fb(i,j,a,b,1) = temp
	  end do
	end do
  end do
end do

!write(6,*)'x_known(1) = ',x_known(1)
!write(6,*)'x_known(2) = ',x_known(2)
!write(6,*)'x_known(3) = ',x_known(3)
!write(6,*)'rhox1 = ',rhox1
!write(6,*)'rhox2 = ',rhox2

!	Calculate the SAFT properties of the given phase (I)


call PTthermo_props(ncp, max, status11, TK, rhox1, m, x_known, u0, e_ii, kij, N_sites, fa, &
						& fb, kappa, sig, D, v00, Prsm, Ursm, Arsm, Grsm, Srsm, Hrsm, chpt1, &
						& Pcalc1, fugacity1, chpt_res1, Gtotal, disp_flag) 


!	Calculate the SAFT properties of the 2nd phase (II)

call PTthermo_props(ncp, max, status11, TK, rhox2, m, x_guess, u0, e_ii, kij, N_sites, fa, &
						& fb, kappa, sig, D, v00, Prsm, Ursm, Arsm, Grsm, Srsm, Hrsm, chpt2, &
						& Pcalc2, fugacity2, chpt_res2, Gtotal, disp_flag) 


KB_result1 = ( chpt_res1(1) - chpt_res1(2) ) / (MW_tmp(1) - MW_tmp(2) )
KB_result2 = ( chpt_res2(1) - chpt_res2(2) ) / (MW_tmp(1) - MW_tmp(2) )

KB_new = KB_result1 - KB_result2


KA_result1 = ( MW_tmp(2)*chpt_res1(1) - MW_tmp(1)*chpt_res1(2) ) / (MW_tmp(2) - MW_tmp(1) )
KA_result2 = ( MW_tmp(2)*chpt_res2(1) - MW_tmp(1)*chpt_res2(2) ) / (MW_tmp(2) - MW_tmp(1) )


KA_new = dlog(rhox1/rhox2) + KA_result1 - KA_result2

!write(6,*)'KA_new = ',KA_new
!write(6,*)'KB_new = ',KB_new


END SUBROUTINE