(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     14686,        406]*)
(*NotebookOutlinePosition[     15391,        429]*)
(*  CellTagsIndexPosition[     15347,        425]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(t1[\[Eta]_] := \((Exp[
                A[\[Eta]]\ \[Gamma]]\ \((\[Lambda]\ A[\[Eta]] - 1)\) - 
            A[\[Eta]] + 1)\)/A[\[Eta]]^2\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(t1'\)[\[Eta]]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        FractionBox[
          RowBox[{
          "2", " ", \((1 - 
                A[\[Eta]] + \[ExponentialE]\^\(\[Gamma]\ A[\[Eta]]\)\ \((\(-1\
\) + \[Lambda]\ A[\[Eta]])\))\), " ", 
            RowBox[{
              SuperscriptBox["A", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", 
              "]"}]}], \(A[\[Eta]]\^3\)]}], "+", 
      FractionBox[
        RowBox[{
          RowBox[{"-", 
            RowBox[{
              SuperscriptBox["A", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
          
          RowBox[{\(\[ExponentialE]\^\(\[Gamma]\ A[\[Eta]]\)\), " ", 
            "\[Lambda]", " ", 
            RowBox[{
              SuperscriptBox["A", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
          
          RowBox[{\(\[ExponentialE]\^\(\[Gamma]\ A[\[Eta]]\)\), " ", 
            "\[Gamma]", " ", \((\(-1\) + \[Lambda]\ A[\[Eta]])\), " ", 
            RowBox[{
              SuperscriptBox["A", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", 
              "]"}]}]}], \(A[\[Eta]]\^2\)]}]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(t2[\[Eta]_] := \((\[Lambda]\ Exp[
                  B[\[Eta]]\ \[Gamma]]\ \((B[\[Eta]]\ Cos[
                        CC[\[Eta]]\ \[Gamma]] + 
                    CC[\[Eta]]\ Sin[CC[\[Eta]]\ \[Gamma]])\) - 
              B[\[Eta]])\)/\((B[\[Eta]]^2 + 
              CC[\[Eta]]^2)\) - \((Exp[
                  B[\[Eta]]\ \[Gamma]]\ \((\((B[\[Eta]]^2 - 
                          CC[\[Eta]]^2)\)\ Cos[CC[\[Eta]]\ \[Gamma]] + 
                    2\ B[\[Eta]]\ CC[\[Eta]]\ Sin[
                        CC[\[Eta]]\ \[Gamma]])\)\  - \ \((B[\[Eta]]^2 - 
                  CC[\[Eta]]^2)\))\)/\((B[\[Eta]]^2 + 
                CC[\[Eta]]^2)\)^2\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(t2'\)[\[Eta]]]\)], "Input"],

Cell["\<\
        -(((-B(\[Eta]) + E**(\[Gamma]*B(\[Eta]))*\[Lambda]*(B(\[Eta])*Cos(\
\[Gamma]*CC(\[Eta])) + CC(\[Eta])*Sin(\[Gamma]*CC(\[Eta]))))*
     -       (2*B(\[Eta])*Derivative(1)(B)(\[Eta]) + \
2*CC(\[Eta])*Derivative(1)(CC)(\[Eta])))/(B(\[Eta])**2 + CC(\[Eta])**2)**2) + \

     -  (2*(-B(\[Eta])**2 + CC(\[Eta])**2 + \
E**(\[Gamma]*B(\[Eta]))*((B(\[Eta])**2 - \
CC(\[Eta])**2)*Cos(\[Gamma]*CC(\[Eta])) + \
2*B(\[Eta])*CC(\[Eta])*Sin(\[Gamma]*CC(\[Eta]))))*
     -     (2*B(\[Eta])*Derivative(1)(B)(\[Eta]) + \
2*CC(\[Eta])*Derivative(1)(CC)(\[Eta])))/(B(\[Eta])**2 + CC(\[Eta])**2)**3 + 
     -  (-Derivative(1)(B)(\[Eta]) + E**(\[Gamma]*B(\[Eta]))*\[Gamma]*\
\[Lambda]*(B(\[Eta])*Cos(\[Gamma]*CC(\[Eta])) + CC(\[Eta])*Sin(\[Gamma]*CC(\
\[Eta])))*Derivative(1)(B)(\[Eta]) + 
     -     \
E**(\[Gamma]*B(\[Eta]))*\[Lambda]*(Cos(\[Gamma]*CC(\[Eta]))*Derivative(1)(B)(\
\[Eta]) + \[Gamma]*CC(\[Eta])*Cos(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\
\[Eta]) + 
     -        Sin(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\[Eta]) - \
\[Gamma]*B(\[Eta])*Sin(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\[Eta])))/(B(\
\[Eta])**2 + CC(\[Eta])**2) - 
     -  (-2*B(\[Eta])*Derivative(1)(B)(\[Eta]) + E**(\[Gamma]*B(\[Eta]))*\
\[Gamma]*((B(\[Eta])**2 - CC(\[Eta])**2)*Cos(\[Gamma]*CC(\[Eta])) + \
2*B(\[Eta])*CC(\[Eta])*Sin(\[Gamma]*CC(\[Eta])))*
     -      Derivative(1)(B)(\[Eta]) + 2*CC(\[Eta])*Derivative(1)(CC)(\[Eta]) \
+ 
     -     \
E**(\[Gamma]*B(\[Eta]))*(2*CC(\[Eta])*Sin(\[Gamma]*CC(\[Eta]))*Derivative(1)(\
B)(\[Eta]) + \
2*\[Gamma]*B(\[Eta])*CC(\[Eta])*Cos(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\
\[Eta]) + 
     -        2*B(\[Eta])*Sin(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\[Eta]) \
- \[Gamma]*(B(\[Eta])**2 - \
CC(\[Eta])**2)*Sin(\[Gamma]*CC(\[Eta]))*Derivative(1)(CC)(\[Eta]) + 
     -        Cos(\[Gamma]*CC(\[Eta]))*(2*B(\[Eta])*Derivative(1)(B)(\[Eta]) \
- 2*CC(\[Eta])*Derivative(1)(CC)(\[Eta]))))/(B(\[Eta])**2 + CC(\[Eta])**2)**2\
\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(t3[\[Eta]_] := \((\[Lambda]\ Exp[
                  B[\[Eta]]\ \[Gamma]]\ \((B[\[Eta]]\ Sin[
                        CC[\[Eta]]\ \[Gamma]] - 
                    CC[\[Eta]]\ Cos[CC[\[Eta]]\ \[Gamma]])\) + 
              CC[\[Eta]])\)/\((B[\[Eta]]^2 + 
              CC[\[Eta]]^2)\) - \((Exp[
                  B[\[Eta]]\ \[Gamma]]\ \((\((B[\[Eta]]^2 - 
                          CC[\[Eta]]^2)\)\ Sin[CC[\[Eta]]\ \[Gamma]] - 
                    2\ B[\[Eta]]\ CC[\[Eta]]\ Cos[CC[\[Eta]]\ \[Gamma]])\) + 
              2\ B[\[Eta]]\ CC[\[Eta]])\)/\((B[\[Eta]]^2 + 
                CC[\[Eta]]^2)\)^2\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(t3'\)[eta]]\)], "Input"],

Cell["\<\
        -(((CC(eta) + \
E**(\[Gamma]*B(eta))*\[Lambda]*(-(CC(eta)*Cos(\[Gamma]*CC(eta))) + \
B(eta)*Sin(\[Gamma]*CC(eta))))*
     -       (2*B(eta)*Derivative(1)(B)(eta) + \
2*CC(eta)*Derivative(1)(CC)(eta)))/(B(eta)**2 + CC(eta)**2)**2) + 
     -  (2*(2*B(eta)*CC(eta) + E**(\[Gamma]*B(eta))*(-2*B(eta)*CC(eta)*Cos(\
\[Gamma]*CC(eta)) + (B(eta)**2 - CC(eta)**2)*Sin(\[Gamma]*CC(eta))))*
     -     (2*B(eta)*Derivative(1)(B)(eta) + \
2*CC(eta)*Derivative(1)(CC)(eta)))/(B(eta)**2 + CC(eta)**2)**3 + 
     -  (E**(\[Gamma]*B(eta))*\[Gamma]*\[Lambda]*(-(CC(eta)*Cos(\[Gamma]*CC(\
eta))) + B(eta)*Sin(\[Gamma]*CC(eta)))*Derivative(1)(B)(eta) + \
Derivative(1)(CC)(eta) + 
     -     \
E**(\[Gamma]*B(eta))*\[Lambda]*(Sin(\[Gamma]*CC(eta))*Derivative(1)(B)(eta) - \
Cos(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta) + 
     -        \[Gamma]*B(eta)*Cos(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta) + \
\[Gamma]*CC(eta)*Sin(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta)))/
     -   (B(eta)**2 + CC(eta)**2) - (2*CC(eta)*Derivative(1)(B)(eta) + 
     -     \
E**(\[Gamma]*B(eta))*\[Gamma]*(-2*B(eta)*CC(eta)*Cos(\[Gamma]*CC(eta)) + \
(B(eta)**2 - CC(eta)**2)*Sin(\[Gamma]*CC(eta)))*Derivative(1)(B)(eta) + 
     -     2*B(eta)*Derivative(1)(CC)(eta) + E**(\[Gamma]*B(eta))*
     -      (-2*CC(eta)*Cos(\[Gamma]*CC(eta))*Derivative(1)(B)(eta) - \
2*B(eta)*Cos(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta) + 
     -        \[Gamma]*(B(eta)**2 - \
CC(eta)**2)*Cos(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta) + 
     -        \
2*\[Gamma]*B(eta)*CC(eta)*Sin(\[Gamma]*CC(eta))*Derivative(1)(CC)(eta) + 
     -        Sin(\[Gamma]*CC(eta))*(2*B(eta)*Derivative(1)(B)(eta) - \
2*CC(eta)*Derivative(1)(CC)(eta))))/(B(eta)**2 + CC(eta)**2)**2\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(a1[\[Eta]_] := \((\(-2\)\ \[Eta]\ \((1 - \[Eta] - 
                  3\ \[Eta]^2)\) + \((1 - 3\ \[Eta] - 
                  4  \[Eta]^2)\)\ zd[\[Eta]] + \((1 + \[Eta]/
                    2)\)\ zd[\[Eta]]^2)\)/\((3\ \((2\ \[Eta]^2 + 
                zd[\[Eta]]^2)\)\ \((1 - \[Eta])\)^2)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(a1'\)[eta]]\)], "Input"],

Cell["\<\
        (2*(-2*eta*(1 - eta - 3*eta**2) + 
     -       (1 - 3*eta - 4*eta**2)*zd(eta) + 
     -       (1 + eta/2.)*zd(eta)**2))/
     -   (3.*(1 - eta)**3*(2*eta**2 + zd(eta)**2)) - 
     -  ((-2*eta*(1 - eta - 3*eta**2) + 
     -       (1 - 3*eta - 4*eta**2)*zd(eta) + 
     -       (1 + eta/2.)*zd(eta)**2)*
     -     (4*eta + 2*zd(eta)*Derivative(1)(zd)(eta)))/
     -   (3.*(1 - eta)**2*(2*eta**2 + zd(eta)**2)**2) + 
     -  (-2*(-1 - 6*eta)*eta - 2*(1 - eta - 3*eta**2) + 
     -     (-3 - 8*eta)*zd(eta) + zd(eta)**2/2. + 
     -     (1 - 3*eta - 4*eta**2)*Derivative(1)(zd)(eta) + 
     -     2*(1 + eta/2.)*zd(eta)*Derivative(1)(zd)(eta))/
     -   (3.*(1 - eta)**2*(2*eta**2 + zd(eta)**2))\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(a2[\[Eta]_] := \((\[Eta]\ \((2 + 4\ \[Eta] - 3\ \[Eta]^2)\) - \((1 - 
                  3\ \[Eta] - 4\ \[Eta]^2)\)\ zd[\[Eta]] + 
            2\ \((1 + \[Eta]/2)\)\ zd[\[Eta]]^2)\)/\((3\ \((2\ \[Eta]^2 + 
                zd[\[Eta]]^2)\)\ \((1 - \[Eta])\)^2)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(a2'\)[eta]]\)], "Input"],

Cell["\<\
        (2*(eta*(2 + 4*eta - 3*eta**2) - 
     -       (1 - 3*eta - 4*eta**2)*zd(eta) + 
     -       2*(1 + eta/2.)*zd(eta)**2))/
     -   (3.*(1 - eta)**3*(2*eta**2 + zd(eta)**2)) - 
     -  ((eta*(2 + 4*eta - 3*eta**2) - 
     -       (1 - 3*eta - 4*eta**2)*zd(eta) + 
     -       2*(1 + eta/2.)*zd(eta)**2)*
     -     (4*eta + 2*zd(eta)*Derivative(1)(zd)(eta)))/
     -   (3.*(1 - eta)**2*(2*eta**2 + zd(eta)**2)**2) + 
     -  (2 + 4*eta + (4 - 6*eta)*eta - 3*eta**2 - 
     -     (-3 - 8*eta)*zd(eta) + zd(eta)**2 - 
     -     (1 - 3*eta - 4*eta**2)*Derivative(1)(zd)(eta) + 
     -     4*(1 + eta/2.)*zd(eta)*Derivative(1)(zd)(eta))/
     -   (3.*(1 - eta)**2*(2*eta**2 + zd(eta)**2))\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(a3[\[Eta]_] := \((\((1 - 3\ \[Eta] - 4\ \[Eta]^2)\)\ \((4\ \[Eta]^2 + 
                  zd[\[Eta]]^2)\) + \[Eta]\ \((2 - 
                  5\ \[Eta]^2)\)\ zd[\[Eta]])\)/\((\((3)\)^\((1/
                  2)\)\ zs[\[Eta]]\ \((2\ \[Eta]^2 + 
                zd[\[Eta]]^2)\)\ \((1 - \[Eta])\)^2)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(a3'\)[eta]]\)], "Input"],

Cell["\<\
        (2*(eta*(2 - 5*eta**2)*zd(eta) + 
     -       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd(eta)**2)
     -       ))/
     -   (Sqrt(3)*(1 - eta)**3*(2*eta**2 + zd(eta)**2)*
     -     zs(eta)) - ((eta*(2 - 5*eta**2)*zd(eta) + 
     -       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd(eta)**2)
     -       )*(4*eta + 2*zd(eta)*Derivative(1)(zd)(eta)))/
     -   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd(eta)**2)**2*
     -     zs(eta)) + (-10*eta**2*zd(eta) + 
     -     (2 - 5*eta**2)*zd(eta) + 
     -     (-3 - 8*eta)*(4*eta**2 + zd(eta)**2) + 
     -     eta*(2 - 5*eta**2)*Derivative(1)(zd)(eta) + 
     -     (1 - 3*eta - 4*eta**2)*
     -      (8*eta + 2*zd(eta)*Derivative(1)(zd)(eta)))/
     -   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd(eta)**2)*
     -     zs(eta)) - ((eta*(2 - 5*eta**2)*zd(eta) + 
     -       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd(eta)**2)
     -       )*Derivative(1)(zs)(eta))/
     -   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd(eta)**2)*
     -     zs(eta)**2)\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(A[\[Eta]_] := \((\(-2\)\ \[Eta] + 
            zd[\[Eta]])\)/\((1 - \[Eta])\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(A'\)[eta]]\)], "Input"],

Cell["\<\
        (-2*eta + zd(eta))/(1 - eta)**2 + 
     -  (-2 + Derivative(1)(zd)(eta))/(1 - eta)\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(B[\[Eta]_] := \((\(-2\)\ \[Eta] - 
            0.5\ zd[\[Eta]])\)/\((1 - \[Eta])\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(B'\)[eta]]\)], "Input"],

Cell["\<\
        (-2*eta - 0.5*zd(eta))/(1 - eta)**2 + 
     -  (-2 - 0.5*Derivative(1)(zd)(eta))/(1 - eta)\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(CC[\[Eta]_] := \((3^\((1/
                  2)\)\ zs[\[Eta]])\)/\((2\ \((1 - \[Eta])\))\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(CC'\)[eta]]\)], "Input"],

Cell["\<\
        (Sqrt(3)*zs(eta))/(2.*(1 - eta)**2) + 
     -  (Sqrt(3)*Derivative(1)(zs)(eta))/(2.*(1 - eta))\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(yp[\[Eta]_] := \((2\ \[Eta]\ f[\[Eta]])\)^
          h\ \((\((2\ \[Eta]^4/f[\[Eta]]^2 + 1)\)^0.5 + 1)\)^h\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(yp'\)[eta]]\)], "Input"],

Cell["\<\
        2**h*h*(1 + (1 + (2*eta**4)/f(eta)**2)**0.5)**h*
     -   (eta*f(eta))**(-1 + h)*
     -   (f(eta) + eta*Derivative(1)(f)(eta)) + 
     -  (0.5*2**h*h*(1 + (1 + (2*eta**4)/f(eta)**2)**0.5)**
     -      (-1 + h)*(eta*f(eta))**h*
     -     ((8*eta**3)/f(eta)**2 - 
     -       (4*eta**4*Derivative(1)(f)(eta))/f(eta)**3))/
     -   (1 + (2*eta**4)/f(eta)**2)**0.5\
\>", "Output"]
}, Open  ]],

Cell[BoxData[
    \(ym[\[Eta]_] := \((2\ \[Eta]\ f[\[Eta]])\)^
          h\ \((\((2  \[Eta]^4/f[\[Eta]]^2 + 1)\)^0.5 - 1)\)^h\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(ym'\)[eta]]\)], "Input"],

Cell["\<\
        2**h*h*(-1 + (1 + (2*eta**4)/f(eta)**2)**0.5)**h*
     -   (eta*f(eta))**(-1 + h)*
     -   (f(eta) + eta*Derivative(1)(f)(eta)) + 
     -  (0.5*2**h*h*(-1 + 
     -        (1 + (2*eta**4)/f(eta)**2)**0.5)**(-1 + h)*
     -     (eta*f(eta))**h*
     -     ((8*eta**3)/f(eta)**2 - 
     -       (4*eta**4*Derivative(1)(f)(eta))/f(eta)**3))/
     -   (1 + (2*eta**4)/f(eta)**2)**0.5\
\>", "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(f[eta_] = 3 + 3\ eta - eta^2\)], "Input"],

Cell[BoxData[
    \(3 + 3\ eta - eta\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FortranForm[\(f'\)[eta]]\)], "Input"],

Cell["3 - 2*eta", "Output"]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{499, 537},
WindowMargins->{{19, Automatic}, {34, Automatic}},
PrintingOptions->{"PrintingMargins"->{{72, 72}, {54, 54}}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 168, 3, 30, "Input"],

Cell[CellGroupData[{
Cell[1947, 58, 48, 1, 30, "Input"],
Cell[1998, 61, 1192, 30, 87, "Output"]
}, Open  ]],
Cell[3205, 94, 669, 12, 130, "Input"],

Cell[CellGroupData[{
Cell[3899, 110, 61, 1, 30, "Input"],
Cell[3963, 113, 1965, 38, 519, "Output"]
}, Open  ]],
Cell[5943, 154, 629, 11, 130, "Input"],

Cell[CellGroupData[{
Cell[6597, 169, 58, 1, 30, "Input"],
Cell[6658, 172, 1733, 31, 672, "Output"]
}, Open  ]],
Cell[8406, 206, 321, 5, 70, "Input"],

Cell[CellGroupData[{
Cell[8752, 215, 58, 1, 30, "Input"],
Cell[8813, 218, 727, 15, 281, "Output"]
}, Open  ]],
Cell[9555, 236, 292, 4, 70, "Input"],

Cell[CellGroupData[{
Cell[9872, 244, 58, 1, 30, "Input"],
Cell[9933, 247, 720, 15, 281, "Output"]
}, Open  ]],
Cell[10668, 265, 329, 5, 70, "Input"],

Cell[CellGroupData[{
Cell[11022, 274, 58, 1, 30, "Input"],
Cell[11083, 277, 1003, 21, 434, "Output"]
}, Open  ]],
Cell[12101, 301, 110, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[12236, 307, 57, 1, 30, "Input"],
Cell[12296, 310, 116, 3, 60, "Output"]
}, Open  ]],
Cell[12427, 316, 115, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[12567, 322, 57, 1, 30, "Input"],
Cell[12627, 325, 124, 3, 60, "Output"]
}, Open  ]],
Cell[12766, 331, 122, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[12913, 337, 58, 1, 30, "Input"],
Cell[12974, 340, 128, 3, 60, "Output"]
}, Open  ]],
Cell[13117, 346, 138, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[13280, 352, 58, 1, 30, "Input"],
Cell[13341, 355, 398, 9, 179, "Output"]
}, Open  ]],
Cell[13754, 367, 138, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[13917, 373, 58, 1, 30, "Input"],
Cell[13978, 376, 414, 10, 179, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14429, 391, 61, 1, 30, "Input"],
Cell[14493, 394, 53, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14583, 400, 57, 1, 30, "Input"],
Cell[14643, 403, 27, 0, 43, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

